//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include <stdio.h>

#include "Debug.h"
#define NOTYPEREDEF
#include "cpudefs.h"
#include "gotodialog.h"
#include "Value.h"
#include "Entry.h"
#include "Data.h"
#include "Search.h"
#include "Log.h"
#include "EditLog.h"
#include "AddLog.h"

#define ROMTBL(x) readmem24_dword(readmem24_dword(0xc8)+(x)*4)
#define HANDLE_TABLE readmem24_dword(ROMTBL(0x2f)+0x11a)
#define HANDLE(x) readmem24_dword(HANDLE_TABLE+4*(x))

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TDebugWnd *DebugWnd;
int debug=0;
int run=1;
int debugStartPC,debugStartMem;
int debugEnforceAddr=0;
int debugFirstInstrucLen;
int debugCodeBreakCount,debugCodeBreak[256];
int debugDataBreakCount,debugDataBreakType[256];
int debugDataBreakLow[256],debugDataBreakHigh[256];
int debugDataBreak;
int debugProgBreak,debugProgBreakOfs;
int debugBeginStepOver,debugEndStepOver;
int debugStepOver,debugStepGoal;
int debugStepA7;
int debugForceUpdate;
int debugLogEnable;
int debugLogCount;
int debugLogClass[256];
int debugLogType[256];
int debugLogLow[256];
int debugLogHigh[256];
int debugLogCheck[256];
int debugLogLast[256];
int debugLogState[256];
int debugLogAny[256];
int debugLogLinkSend,debugLogLinkRecv;
extern int readmem24(int a);
extern int readmem24_word(int a);
extern int readmem24_dword(int a);
extern int writemem24(int a,int v);
extern int writemem24_word(int a,int v);
extern int writemem24_dword(int a,int v);
extern void UseDebugReadFuncs();
extern void RestoreReadFuncs();
extern void RefreshLCDNow();
extern char *ram;
extern int Dasm68000 (unsigned char *pBase, char *buffer, int pc);
extern int lcdUpdate;
extern int calc,plusMod;
int oldHandleCount=0;
int oldHandleList[0x800];
//---------------------------------------------------------------------------
__fastcall TDebugWnd::TDebugWnd(TComponent* Owner)
    : TForm(Owner)
{
    debugStartMem=0;
    debugProgBreak=0;
    debugCodeBreakCount=0;
    debugDataBreakCount=0;
    debugDataBreak=0;
    debugStepOver=0;
    debugBeginStepOver=0;
    debugForceUpdate=1;
    debugLogEnable=0;
    debugLogCount=0;
    debugLogLinkSend=0;
    debugLogLinkRecv=0;
}
//---------------------------------------------------------------------------
extern int romWriteReady,romWritePhase;
void __fastcall TDebugWnd::Update()
{
    char str[256],str2[256];
    int useOldPC=0;

    if ((!run)&&debugStepOver)
        debugStepOver=0;
    if ((!run)&&debugDataBreak)
    {
        debugDataBreak=0;
        useOldPC=1;
    }
    lcdUpdate=1;
    int chg,i,j,k,max,n=0;
    if ((calc!=92)||(plusMod))
    {
        max=readmem24_word(ROMTBL(0x2f)+0x104);
        if (max>0x800) max=0x800;
        for (i=0,chg=0;i<max;i++)
        {
            int addr=readmem24_dword(HANDLE_TABLE+4*i);
            if (addr)
            {
                n=i+1;
                if (addr!=oldHandleList[i])
                    chg=1;
            }
        }
        if ((n!=oldHandleCount)||chg)
        {
            Handles->Clear();
            for (i=0;i<n;i++)
            {
                int addr=readmem24_dword(HANDLE_TABLE+4*i);
                sprintf(str,"$%4.4X -> $%6.6X",i,addr);
                oldHandleList[i]=addr;
                Handles->Items->Add(str);
            }
            oldHandleCount=n;
        }
    }
    else
        Handles->Clear();
    sprintf(str,"D0=%8.8X",regs.d[0]); D0->Caption=str; D0->Update();
    sprintf(str,"D1=%8.8X",regs.d[1]); D1->Caption=str; D1->Update();
    sprintf(str,"D2=%8.8X",regs.d[2]); D2->Caption=str; D2->Update();
    sprintf(str,"D3=%8.8X",regs.d[3]); D3->Caption=str; D3->Update();
    sprintf(str,"D4=%8.8X",regs.d[4]); D4->Caption=str; D4->Update();
    sprintf(str,"D5=%8.8X",regs.d[5]); D5->Caption=str; D5->Update();
    sprintf(str,"D6=%8.8X",regs.d[6]); D6->Caption=str; D6->Update();
    sprintf(str,"D7=%8.8X",regs.d[7]); D7->Caption=str; D7->Update();
    sprintf(str,"A0=%8.8X",regs.a[0]); A0->Caption=str; A0->Update();
    sprintf(str,"A1=%8.8X",regs.a[1]); A1->Caption=str; A1->Update();
    sprintf(str,"A2=%8.8X",regs.a[2]); A2->Caption=str; A2->Update();
    sprintf(str,"A3=%8.8X",regs.a[3]); A3->Caption=str; A3->Update();
    sprintf(str,"A4=%8.8X",regs.a[4]); A4->Caption=str; A4->Update();
    sprintf(str,"A5=%8.8X",regs.a[5]); A5->Caption=str; A5->Update();
    sprintf(str,"A6=%8.8X",regs.a[6]); A6->Caption=str; A6->Update();
    sprintf(str,"A7=%8.8X",regs.a[7]); A7->Caption=str; A7->Update();
    sprintf(str,"PC=%6.6X",regs.pc); PC->Caption=str; PC->Update();
    MakeSR();
    sprintf(str,"SR=%4.4X",regs.sr&0xffff); SR->Caption=str; SR->Update();
    sprintf(str,"T=%d",(regs.t1<<1)+regs.t0); TFlag->Caption=str; TFlag->Update();
    sprintf(str,"S=%d",regs.s); SFlag->Caption=str; SFlag->Update();
    sprintf(str,"M=%d",regs.m); MFlag->Caption=str; MFlag->Update();
    sprintf(str,"I=%d",regs.intmask); IFlag->Caption=str; IFlag->Update();
    sprintf(str,"X=%d",regs.x); XFlag->Caption=str; XFlag->Update();
    sprintf(str,"N=%d",NFLG); NFlag->Caption=str; NFlag->Update();
    sprintf(str,"Z=%d",ZFLG); ZFlag->Caption=str; ZFlag->Update();
    sprintf(str,"C=%d",CFLG); CFlag->Caption=str; CFlag->Update();
    sprintf(str,"V=%d",VFLG); VFlag->Caption=str; ZFlag->Update();
    int updateCode=1;
    if ((Code->Items->Count)&&(!debugEnforceAddr))
    {
        for (i=0,j=-1,k=-1;i<15;i++)
        {
            int addr;
            sscanf(Code->Items->Strings[i].c_str(),"%x",&addr);
            if (addr==regs.pc)
            {
                j=i;
                if (!useOldPC) k=i;
            }
            if ((useOldPC)&&(addr==debugStartPC))
                k=i;
        }
        if ((j!=-1)&&(k==-1)) k=j;
        if (j!=-1)
        {
            if (j>=11)
            {
                sscanf(Code->Items->Strings[j-10].c_str(),
                    "%x",&debugStartPC);
            }
            else
            {
                sscanf(Code->Items->Strings[0].c_str(),
                    "%x",&debugStartPC);
                if (!debugForceUpdate)
                    updateCode=0;
                for (i=0;i<15;i++)
                {
                    if (i==j)
                    {
                        strcpy(str,Code->Items->Strings[i].c_str());
                        str[6]='-'; str[7]='>';
                        Code->Items->Strings[i]=str;
                    }
                    else
                    {
                        strcpy(str,Code->Items->Strings[i].c_str());
                        str[6]=':'; str[7]=' ';
                        Code->Items->Strings[i]=str;
                    }
                }
                Code->ItemIndex=k;
            }
        }
    }
    debugEnforceAddr=0;
    if (updateCode)
    {
        unsigned short buf[256];
        for (i=0;i<256;i++)
            buf[i]=readmem24_word(debugStartPC+(i<<1));
        Code->Clear();
        for (i=0,j=0,k=-1;i<15;i++)
        {
            int oj=j;
            j+=Dasm68000((BYTE*)(buf+(j>>1)),str,debugStartPC+j);
            if (i==0) debugFirstInstrucLen=j;
            if ((debugStartPC+oj)!=regs.pc)
                sprintf(str2,"%6.6X: %s",(debugStartPC+oj)&0xffffff,str);
            else
            {
                sprintf(str2,"%6.6X->%s",(debugStartPC+oj)&0xffffff,str);
                k=i;
            }
            Code->Items->Add(str2);
        }
        Code->ItemIndex=k;
    }
    Code->Update();
    Stack->Clear();
    for (i=0;i<16;i++)
    {
        sprintf(str,"%6.6X: %4.4X",regs.a[7]+(i*2),
            readmem24_word(regs.a[7]+(i*2)));
        Stack->Items->Add(str);
    }
    Stack->Update();
    UpdateMem();
    RefreshLCDNow();
    debugForceUpdate=0;
}

void __fastcall TDebugWnd::UpdateMem()
{
    int i,j;
    char str[32];
    TListBox *memCol[8]={MemCol0,MemCol1,MemCol2,MemCol3,
        MemCol4,MemCol5,MemCol6,MemCol7};
    MemAddr->Clear(); MemCol0->Clear(); MemCol1->Clear();
    MemCol2->Clear(); MemCol3->Clear(); MemCol4->Clear();
    MemCol5->Clear(); MemCol6->Clear(); MemCol7->Clear();
    MemText->Clear();
    for (i=0;i<0x30;)
    {
        sprintf(str,"%6.6X",(debugStartMem+i)&0xffffff);
        MemAddr->Items->Add(str);
        for (j=0;j<8;j++)
        {
            sprintf(str,"%2.2X",readmem24(debugStartMem+i+j));
            memCol[j]->Items->Add(str);
        }
        str[8]=0;
        for (j=0;j<8;j++,i++)
        {
            int c=readmem24(debugStartMem+i)&0xff;
            if ((c>=32)&&(c<128))
                str[j]=c;
            else
                str[j]='.';
        }
        MemText->Items->Add(str);
    }
}

void __fastcall TDebugWnd::FormCloseQuery(TObject *Sender, bool &CanClose)
{
    debug=0; run=1;
    CanClose=false;
    Hide();
    debugForceUpdate=1;
}
//---------------------------------------------------------------------------

void DoOneInstruction();

void __fastcall TDebugWnd::Step1Click(TObject *Sender)
{
    DoOneInstruction();
    debugStartPC=regs.pc;
    Update();    
}
//---------------------------------------------------------------------------


void __fastcall TDebugWnd::Run1Click(TObject *Sender)
{
    debug=0; run=1;
    Hide();
    debugForceUpdate=1;
}
//---------------------------------------------------------------------------


void __fastcall TDebugWnd::CodeKeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
    if (Key==VK_PRIOR)
    {
        debugStartPC-=2;
        debugEnforceAddr=1;
        Update();
    }
    else if (Key==VK_NEXT)
    {
        debugStartPC+=debugFirstInstrucLen;
        debugEnforceAddr=1;
        Update();
    }
    else if (Key==VK_UP)
    {
        if (Code->ItemIndex==0)
        {
            debugStartPC-=2;
            debugEnforceAddr=1;
            Update();
            Code->ItemIndex=0;
        }
    }
    else if (Key==VK_DOWN)
    {
        if (Code->ItemIndex==14)
        {
            debugStartPC+=debugFirstInstrucLen;
            debugEnforceAddr=1;
            Update();
            Code->ItemIndex=14;
        }
    }
}
//---------------------------------------------------------------------------

void __fastcall TDebugWnd::Gotoaddress1Click(TObject *Sender)
{
    GoToDlg->Address->Text="";
    if (GoToDlg->ShowModal()==1)
    {
        sscanf(GoToDlg->Address->Text.c_str(),"%x",&debugStartPC);
        debugEnforceAddr=1;
        Update();
    }
}
//---------------------------------------------------------------------------

void __fastcall TDebugWnd::SetPC1Click(TObject *Sender)
{
    if (Code->ItemIndex==-1) return;
    sscanf(Code->Items->Strings[Code->ItemIndex].c_str(),
        "%x",&regs.pc);
    Update();
}
//---------------------------------------------------------------------------

void __fastcall TDebugWnd::Break1Click(TObject *Sender)
{
    debug=1; run=0; debugStartPC=regs.pc;
    Update();
}
//---------------------------------------------------------------------------

void __fastcall TDebugWnd::MemCol0KeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
    if (Key==VK_PRIOR)
    {
        int row=((TListBox*)Sender)->ItemIndex;
        debugStartMem-=0x30;
        UpdateMem();
        ((TListBox*)Sender)->ItemIndex=row;
        Key=0;
    }
    else if (Key==VK_NEXT)
    {
        int row=((TListBox*)Sender)->ItemIndex;
        debugStartMem+=0x30;
        UpdateMem();
        ((TListBox*)Sender)->ItemIndex=row;
        Key=0;
    }
    else if (Key==VK_DOWN)
    {
        if (((TListBox *)Sender)->ItemIndex==5)
        {
            debugStartMem+=8;
            UpdateMem();
            ((TListBox *)Sender)->ItemIndex=5;
        }
    }
    else if (Key==VK_UP)
    {
        if (((TListBox *)Sender)->ItemIndex==0)
        {
            debugStartMem-=8;
            UpdateMem();
            ((TListBox *)Sender)->ItemIndex=0;
        }
    }
    else if (Key==VK_LEFT)
    {
        if (Sender==MemCol1)
        {
            MemCol0->ItemIndex=MemCol1->ItemIndex;
            MemCol1->ItemIndex=-1;
            ActiveControl=MemCol0;
        }
        else if (Sender==MemCol2)
        {
            MemCol1->ItemIndex=MemCol2->ItemIndex;
            MemCol2->ItemIndex=-1;
            ActiveControl=MemCol1;
        }
        else if (Sender==MemCol3)
        {
            MemCol2->ItemIndex=MemCol3->ItemIndex;
            MemCol3->ItemIndex=-1;
            ActiveControl=MemCol2;
        }
        else if (Sender==MemCol4)
        {
            MemCol3->ItemIndex=MemCol4->ItemIndex;
            MemCol4->ItemIndex=-1;
            ActiveControl=MemCol3;
        }
        else if (Sender==MemCol5)
        {
            MemCol4->ItemIndex=MemCol5->ItemIndex;
            MemCol5->ItemIndex=-1;
            ActiveControl=MemCol4;
        }
        else if (Sender==MemCol6)
        {
            MemCol5->ItemIndex=MemCol6->ItemIndex;
            MemCol6->ItemIndex=-1;
            ActiveControl=MemCol5;
        }
        else if (Sender==MemCol7)
        {
            MemCol6->ItemIndex=MemCol7->ItemIndex;
            MemCol7->ItemIndex=-1;
            ActiveControl=MemCol6;
        }
        Key=0;
    }
    else if (Key==VK_RIGHT)
    {
        if (Sender==MemCol0)
        {
            MemCol1->ItemIndex=MemCol0->ItemIndex;
            MemCol0->ItemIndex=-1;
            ActiveControl=MemCol1;
        }
        else if (Sender==MemCol1)
        {
            MemCol2->ItemIndex=MemCol1->ItemIndex;
            MemCol1->ItemIndex=-1;
            ActiveControl=MemCol2;
        }
        else if (Sender==MemCol2)
        {
            MemCol3->ItemIndex=MemCol2->ItemIndex;
            MemCol2->ItemIndex=-1;
            ActiveControl=MemCol3;
        }
        else if (Sender==MemCol3)
        {
            MemCol4->ItemIndex=MemCol3->ItemIndex;
            MemCol3->ItemIndex=-1;
            ActiveControl=MemCol4;
        }
        else if (Sender==MemCol4)
        {
            MemCol5->ItemIndex=MemCol4->ItemIndex;
            MemCol4->ItemIndex=-1;
            ActiveControl=MemCol5;
        }
        else if (Sender==MemCol5)
        {
            MemCol6->ItemIndex=MemCol5->ItemIndex;
            MemCol5->ItemIndex=-1;
            ActiveControl=MemCol6;
        }
        else if (Sender==MemCol6)
        {
            MemCol7->ItemIndex=MemCol6->ItemIndex;
            MemCol6->ItemIndex=-1;
            ActiveControl=MemCol7;
        }
        Key=0;
    }
    else if (Key==VK_RETURN)
    {
        if (Sender==MemCol0)
            MemDblClick(0,MemCol0->ItemIndex);
        else if (Sender==MemCol1)
            MemDblClick(1,MemCol1->ItemIndex);
        else if (Sender==MemCol2)
            MemDblClick(2,MemCol2->ItemIndex);
        else if (Sender==MemCol3)
            MemDblClick(3,MemCol3->ItemIndex);
        else if (Sender==MemCol4)
            MemDblClick(4,MemCol4->ItemIndex);
        else if (Sender==MemCol5)
            MemDblClick(5,MemCol5->ItemIndex);
        else if (Sender==MemCol6)
            MemDblClick(6,MemCol6->ItemIndex);
        else if (Sender==MemCol7)
            MemDblClick(7,MemCol7->ItemIndex);
    }
}
//---------------------------------------------------------------------------

void __fastcall TDebugWnd::MemGotoClick(TObject *Sender)
{
    GoToDlg->Address->Text="";
    if (GoToDlg->ShowModal()==1)
    {
        sscanf(GoToDlg->Address->Text.c_str(),"%x",&debugStartMem);
        UpdateMem();
    }
}

void __fastcall TDebugWnd::MemCol0Click(TObject *Sender)
{
    MemCol1->ItemIndex=-1;
    MemCol2->ItemIndex=-1;
    MemCol3->ItemIndex=-1;
    MemCol4->ItemIndex=-1;
    MemCol5->ItemIndex=-1;
    MemCol6->ItemIndex=-1;
    MemCol7->ItemIndex=-1;
}
//---------------------------------------------------------------------------

void __fastcall TDebugWnd::MemCol1Click(TObject *Sender)
{
    MemCol0->ItemIndex=-1;
    MemCol2->ItemIndex=-1;
    MemCol3->ItemIndex=-1;
    MemCol4->ItemIndex=-1;
    MemCol5->ItemIndex=-1;
    MemCol6->ItemIndex=-1;
    MemCol7->ItemIndex=-1;
}
//---------------------------------------------------------------------------

void __fastcall TDebugWnd::MemCol2Click(TObject *Sender)
{
    MemCol0->ItemIndex=-1;
    MemCol1->ItemIndex=-1;
    MemCol3->ItemIndex=-1;
    MemCol4->ItemIndex=-1;
    MemCol5->ItemIndex=-1;
    MemCol6->ItemIndex=-1;
    MemCol7->ItemIndex=-1;
}
//---------------------------------------------------------------------------

void __fastcall TDebugWnd::MemCol3Click(TObject *Sender)
{
    MemCol0->ItemIndex=-1;
    MemCol1->ItemIndex=-1;
    MemCol2->ItemIndex=-1;
    MemCol4->ItemIndex=-1;
    MemCol5->ItemIndex=-1;
    MemCol6->ItemIndex=-1;
    MemCol7->ItemIndex=-1;
}
//---------------------------------------------------------------------------

void __fastcall TDebugWnd::MemCol4Click(TObject *Sender)
{
    MemCol0->ItemIndex=-1;
    MemCol1->ItemIndex=-1;
    MemCol2->ItemIndex=-1;
    MemCol3->ItemIndex=-1;
    MemCol5->ItemIndex=-1;
    MemCol6->ItemIndex=-1;
    MemCol7->ItemIndex=-1;
}
//---------------------------------------------------------------------------

void __fastcall TDebugWnd::MemCol5Click(TObject *Sender)
{
    MemCol0->ItemIndex=-1;
    MemCol1->ItemIndex=-1;
    MemCol2->ItemIndex=-1;
    MemCol3->ItemIndex=-1;
    MemCol4->ItemIndex=-1;
    MemCol6->ItemIndex=-1;
    MemCol7->ItemIndex=-1;
}
//---------------------------------------------------------------------------

void __fastcall TDebugWnd::MemCol6Click(TObject *Sender)
{
    MemCol0->ItemIndex=-1;
    MemCol1->ItemIndex=-1;
    MemCol2->ItemIndex=-1;
    MemCol3->ItemIndex=-1;
    MemCol4->ItemIndex=-1;
    MemCol5->ItemIndex=-1;
    MemCol7->ItemIndex=-1;
}
//---------------------------------------------------------------------------

void __fastcall TDebugWnd::MemCol7Click(TObject *Sender)
{
    MemCol0->ItemIndex=-1;
    MemCol1->ItemIndex=-1;
    MemCol2->ItemIndex=-1;
    MemCol3->ItemIndex=-1;
    MemCol4->ItemIndex=-1;
    MemCol5->ItemIndex=-1;
    MemCol6->ItemIndex=-1;
}
//---------------------------------------------------------------------------

void __fastcall TDebugWnd::MemDblClick(int col,int selindx)
{
    if (selindx==-1) return;
    int addr=debugStartMem+col+(selindx<<3);
    char str[4];
    sprintf(str,"%2.2X",readmem24(addr)&0xff);
    NewValueDlg->Address->Text=str;
    NewValueDlg->Address->SelectAll();
    NewValueDlg->ActiveControl=NewValueDlg->Address;
    if (NewValueDlg->ShowModal()==1)
    {
        int v;
        sscanf(NewValueDlg->Address->Text.c_str(),"%x",&v);
        writemem24(addr&0xffffff,v);
        int row=selindx;
        UpdateMem();
        switch(col)
        {
            case 0: MemCol0->ItemIndex=row; break;
            case 1: MemCol1->ItemIndex=row; break;
            case 2: MemCol2->ItemIndex=row; break;
            case 3: MemCol3->ItemIndex=row; break;
            case 4: MemCol4->ItemIndex=row; break;
            case 5: MemCol5->ItemIndex=row; break;
            case 6: MemCol6->ItemIndex=row; break;
            case 7: MemCol7->ItemIndex=row; break;
        }
    }
}

void __fastcall TDebugWnd::MemCol0DblClick(TObject *Sender)
{
    MemDblClick(0,MemCol0->ItemIndex);
}
//---------------------------------------------------------------------------

void __fastcall TDebugWnd::MemCol1DblClick(TObject *Sender)
{
    MemDblClick(1,MemCol1->ItemIndex);
}
//---------------------------------------------------------------------------

void __fastcall TDebugWnd::MemCol2DblClick(TObject *Sender)
{
    MemDblClick(2,MemCol2->ItemIndex);
}
//---------------------------------------------------------------------------

void __fastcall TDebugWnd::MemCol3DblClick(TObject *Sender)
{
    MemDblClick(3,MemCol3->ItemIndex);
}
//---------------------------------------------------------------------------

void __fastcall TDebugWnd::MemCol4DblClick(TObject *Sender)
{
    MemDblClick(4,MemCol4->ItemIndex);
}
//---------------------------------------------------------------------------

void __fastcall TDebugWnd::MemCol5DblClick(TObject *Sender)
{
    MemDblClick(5,MemCol5->ItemIndex);
}
//---------------------------------------------------------------------------

void __fastcall TDebugWnd::MemCol6DblClick(TObject *Sender)
{
    MemDblClick(6,MemCol6->ItemIndex);
}
//---------------------------------------------------------------------------

void __fastcall TDebugWnd::MemCol7DblClick(TObject *Sender)
{
    MemDblClick(7,MemCol7->ItemIndex);
}
//---------------------------------------------------------------------------

void __fastcall TDebugWnd::Setbreakpoint1Click(TObject *Sender)
{
    if (Code->ItemIndex==-1) return;
    int pc,i,j;
    sscanf(Code->Items->Strings[Code->ItemIndex].c_str(),
        "%x",&pc);
    for (i=0;i<debugCodeBreakCount;i++)
    {
        if (debugCodeBreak[i]==pc)
        {
            for (j=i;j<(debugCodeBreakCount-1);j++)
                debugCodeBreak[j]=debugCodeBreak[j+1];
            debugCodeBreakCount--;
            Code->Repaint();
            return;
        }
    }
    debugCodeBreak[debugCodeBreakCount++]=pc;
    Code->Repaint();
}
//---------------------------------------------------------------------------

void __fastcall TDebugWnd::CodeDrawItem(TWinControl *Control, int Index,
      TRect &Rect, TOwnerDrawState State)
{
    TBrush *brush=new TBrush;
    TBrush *oldBrush=Code->Canvas->Brush;
    brush->Style=bsSolid;
    TPen *pen=new TPen;
    TPen *oldPen=Code->Canvas->Pen;
    int pos,bp=0;
    sscanf(Code->Items->Strings[Index].c_str(),
        "%X",&pos);
    for (int i=0;i<debugCodeBreakCount;i++)
    {
        if (pos==debugCodeBreak[i])
            bp=1;
    }
    if (State.Contains(odSelected))
    {
        if (Code->Items->Strings[Index].c_str()[6]=='-')
        {
            if (bp)
            {
                brush->Color=clDkGray;
                pen->Color=clWhite;
            }
            else
            {
                brush->Color=clTeal;
                pen->Color=clWhite;
            }
        }
        else
        {
            if (bp)
            {
                brush->Color=clPurple;
                pen->Color=clWhite;
            }
            else
            {
                brush->Color=clNavy;
                pen->Color=clWhite;
            }
        }
    }
    else
    {
        if (Code->Items->Strings[Index].c_str()[6]=='-')
        {
            if (bp)
            {
                brush->Color=clOlive;
                pen->Color=clWhite;
            }
            else
            {
                brush->Color=clGreen;
                pen->Color=clWhite;
            }
        }
        else
        {
            if (bp)
            {
                brush->Color=clMaroon;
                pen->Color=clWhite;
            }
            else
            {
                brush->Color=clWhite;
                pen->Color=clBlack;
            }
        }
    }
    Code->Canvas->Brush=brush;
    Code->Canvas->Pen=pen;
    Code->Canvas->FillRect(Rect);
    Code->Canvas->Font->Color=pen->Color;
    Code->Canvas->TextOut(Rect.Left,Rect.Top,Code->Items->
        Strings[Index]);
    Code->Canvas->Brush=oldBrush;
    Code->Canvas->Pen=oldPen;
}
//---------------------------------------------------------------------------

void __fastcall TDebugWnd::GotoPC1Click(TObject *Sender)
{
    debugStartPC=regs.pc;
    Update();
}
//---------------------------------------------------------------------------

void __fastcall TDebugWnd::Clearallbreakpoints1Click(TObject *Sender)
{
    debugCodeBreakCount=0;
    debugDataBreakCount=0;
    debugProgBreak=0;
    Code->Repaint();
    if ((debugLogEnable&&debugLogCount)||debugDataBreakCount)
        UseDebugReadFuncs();
    else
        RestoreReadFuncs();
}
//---------------------------------------------------------------------------

void __fastcall TDebugWnd::Setbreakpointonprogramentry1Click(
      TObject *Sender)
{
    ProgramEntryDlg->UpdateTree();
    if (ProgramEntryDlg->ShowModal()==1)
    {
        debugProgBreak=((((int)ProgramEntryDlg->Programs->
            Selected->Data)&0xffff)<<2)+HANDLE_TABLE;
        debugProgBreakOfs=(((int)ProgramEntryDlg->Programs->
            Selected->Data)>>16)&0xffff;
    }
}
//---------------------------------------------------------------------------

void __fastcall TDebugWnd::HandlesDblClick(TObject *Sender)
{
    if (Handles->ItemIndex==-1) return;
    int addr;
    sscanf(&((Handles->Items->Strings[Handles->ItemIndex].
        c_str())[10]),"%X",&addr);
    debugStartMem=addr;
    Update();
}
//---------------------------------------------------------------------------

void __fastcall TDebugWnd::Viewmemory1Click(TObject *Sender)
{
    if (Handles->ItemIndex==-1) return;
    int addr;
    sscanf(&((Handles->Items->Strings[Handles->ItemIndex].
        c_str())[10]),"%X",&addr);
    debugStartMem=addr;
    Update();
}
//---------------------------------------------------------------------------

void __fastcall TDebugWnd::Viewdisassembly1Click(TObject *Sender)
{
    if (Handles->ItemIndex==-1) return;
    int addr;
    sscanf(&((Handles->Items->Strings[Handles->ItemIndex].
        c_str())[10]),"%X",&addr);
    debugStartPC=addr+2;
    debugEnforceAddr=1;
    Update();
}
//---------------------------------------------------------------------------
void __fastcall TDebugWnd::Setdatabreakpoint1Click(TObject *Sender)
{
    DataBreakDlg->UpdateList();
    DataBreakDlg->ShowModal();
    if ((debugLogEnable&&debugLogCount)||debugDataBreakCount)
        UseDebugReadFuncs();
    else
        RestoreReadFuncs();
}
//---------------------------------------------------------------------------

void __fastcall TDebugWnd::Searchforvalue1Click(TObject *Sender)
{
    SearchDlg->ActiveControl=SearchDlg->Value;
    if (SearchDlg->ShowModal()==1)
    {
        int v,addr;
        if (SearchDlg->Size->ItemIndex<3)
        {
            sscanf(SearchDlg->Value->Text.c_str(),"%x",&v);
            if (SearchDlg->Size->ItemIndex==0) v&=0xff;
            else if (SearchDlg->Size->ItemIndex==1) v&=0xffff;
            addr=(debugStartMem+2)&0xffffff;
            int size=SearchDlg->Size->ItemIndex;
            if (size!=0) addr&=~1;
            for (;addr<0x600000;addr+=(size==0)?1:2)
            {
                if ((addr>=0x40000)&&(addr<0x200000))
                {
                    addr=0x200000-((size==0)?1:2);
                    continue;
                }
                if (size==0)
                {
                    if ((readmem24(addr)&0xff)==v)
                    {
                        debugStartMem=addr;
                        UpdateMem();
                        break;
                    }
                }
                else if (size==1)
                {
                    if ((readmem24_word(addr)&0xffff)==v)
                    {
                        debugStartMem=addr;
                        UpdateMem();
                        break;
                    }
                }
                else
                {
                    if (readmem24_dword(addr)==v)
                    {
                        debugStartMem=addr;
                        UpdateMem();
                        break;
                    }
                }
            }
        }
        else
        {
            char str[256];
            int indx;

            addr=(debugStartMem+2)&0xffffff;
            strcpy(str,SearchDlg->Value->Text.c_str());
            for (indx=0;addr<0x600000;addr++)
            {
                if ((addr>=0x40000)&&(addr<0x200000))
                {
                    addr=0x200000-1;
                    indx=0;
                    continue;
                }
                if (!str[indx])
                {
                    addr-=strlen(str);
                    debugStartMem=addr;
                    UpdateMem();
                    break;
                }
                if ((readmem24(addr)&0xff)!=(str[indx]&0xff))
                    indx=0;
                else
                    indx++;
            }
        }
        if (addr>=0x600000)
            MessageBox(Handle,"No matches found","Search error",MB_OK);
    }
}
//---------------------------------------------------------------------------

void __fastcall TDebugWnd::Stepover1Click(TObject *Sender)
{
    if (debugStepOver) return;
    unsigned short buf[16];
    char str[64];
    int addr,i;
    for (i=0;i<16;i++)
        buf[i]=readmem24_word(regs.pc+(i<<1));
    addr=regs.pc+Dasm68000((BYTE*)buf,str,regs.pc);
    debugStepOver=1; debugStepGoal=addr;
    debugBeginStepOver=1; debugEndStepOver=0;
    debugStepA7=regs.a[7];
    run=1;
    DoOneInstruction();
}
//---------------------------------------------------------------------------

void __fastcall TDebugWnd::D0Click(TObject *Sender)
{
    char str[4];
    sprintf(str,"%8.8X",regs.d[0]);
    NewValueDlg->Address->Text=str;
    NewValueDlg->Address->SelectAll();
    NewValueDlg->ActiveControl=NewValueDlg->Address;
    if (NewValueDlg->ShowModal()==1)
    {
        sscanf(NewValueDlg->Address->Text.c_str(),"%x",
            &regs.d[0]);
        Update();
    }
}
//---------------------------------------------------------------------------

void __fastcall TDebugWnd::D1Click(TObject *Sender)
{
    char str[4];
    sprintf(str,"%8.8X",regs.d[1]);
    NewValueDlg->Address->Text=str;
    NewValueDlg->Address->SelectAll();
    NewValueDlg->ActiveControl=NewValueDlg->Address;
    if (NewValueDlg->ShowModal()==1)
    {
        sscanf(NewValueDlg->Address->Text.c_str(),"%x",
            &regs.d[1]);
        Update();
    }
}
//---------------------------------------------------------------------------

void __fastcall TDebugWnd::D2Click(TObject *Sender)
{
    char str[4];
    sprintf(str,"%8.8X",regs.d[2]);
    NewValueDlg->Address->Text=str;
    NewValueDlg->Address->SelectAll();
    NewValueDlg->ActiveControl=NewValueDlg->Address;
    if (NewValueDlg->ShowModal()==1)
    {
        sscanf(NewValueDlg->Address->Text.c_str(),"%x",
            &regs.d[2]);
        Update();
    }
}
//---------------------------------------------------------------------------

void __fastcall TDebugWnd::D3Click(TObject *Sender)
{
    char str[4];
    sprintf(str,"%8.8X",regs.d[3]);
    NewValueDlg->Address->Text=str;
    NewValueDlg->Address->SelectAll();
    NewValueDlg->ActiveControl=NewValueDlg->Address;
    if (NewValueDlg->ShowModal()==1)
    {
        sscanf(NewValueDlg->Address->Text.c_str(),"%x",
            &regs.d[3]);
        Update();
    }
}
//---------------------------------------------------------------------------

void __fastcall TDebugWnd::D4Click(TObject *Sender)
{
    char str[4];
    sprintf(str,"%8.8X",regs.d[4]);
    NewValueDlg->Address->Text=str;
    NewValueDlg->Address->SelectAll();
    NewValueDlg->ActiveControl=NewValueDlg->Address;
    if (NewValueDlg->ShowModal()==1)
    {
        sscanf(NewValueDlg->Address->Text.c_str(),"%x",
            &regs.d[4]);
        Update();
    }
}
//---------------------------------------------------------------------------

void __fastcall TDebugWnd::D5Click(TObject *Sender)
{
    char str[4];
    sprintf(str,"%8.8X",regs.d[5]);
    NewValueDlg->Address->Text=str;
    NewValueDlg->Address->SelectAll();
    NewValueDlg->ActiveControl=NewValueDlg->Address;
    if (NewValueDlg->ShowModal()==1)
    {
        sscanf(NewValueDlg->Address->Text.c_str(),"%x",
            &regs.d[5]);
        Update();
    }
}
//---------------------------------------------------------------------------

void __fastcall TDebugWnd::D6Click(TObject *Sender)
{
    char str[4];
    sprintf(str,"%8.8X",regs.d[6]);
    NewValueDlg->Address->Text=str;
    NewValueDlg->Address->SelectAll();
    NewValueDlg->ActiveControl=NewValueDlg->Address;
    if (NewValueDlg->ShowModal()==1)
    {
        sscanf(NewValueDlg->Address->Text.c_str(),"%x",
            &regs.d[6]);
        Update();
    }
}
//---------------------------------------------------------------------------

void __fastcall TDebugWnd::D7Click(TObject *Sender)
{
    char str[4];
    sprintf(str,"%8.8X",regs.d[7]);
    NewValueDlg->Address->Text=str;
    NewValueDlg->Address->SelectAll();
    NewValueDlg->ActiveControl=NewValueDlg->Address;
    if (NewValueDlg->ShowModal()==1)
    {
        sscanf(NewValueDlg->Address->Text.c_str(),"%x",
            &regs.d[7]);
        Update();
    }
}
//---------------------------------------------------------------------------

void __fastcall TDebugWnd::A0Click(TObject *Sender)
{
    char str[4];
    sprintf(str,"%8.8X",regs.a[0]);
    NewValueDlg->Address->Text=str;
    NewValueDlg->Address->SelectAll();
    NewValueDlg->ActiveControl=NewValueDlg->Address;
    if (NewValueDlg->ShowModal()==1)
    {
        sscanf(NewValueDlg->Address->Text.c_str(),"%x",
            &regs.a[0]);
        Update();
    }
}
//---------------------------------------------------------------------------

void __fastcall TDebugWnd::A1Click(TObject *Sender)
{
    char str[4];
    sprintf(str,"%8.8X",regs.a[1]);
    NewValueDlg->Address->Text=str;
    NewValueDlg->Address->SelectAll();
    NewValueDlg->ActiveControl=NewValueDlg->Address;
    if (NewValueDlg->ShowModal()==1)
    {
        sscanf(NewValueDlg->Address->Text.c_str(),"%x",
            &regs.a[1]);
        Update();
    }
}
//---------------------------------------------------------------------------

void __fastcall TDebugWnd::A2Click(TObject *Sender)
{
    char str[4];
    sprintf(str,"%8.8X",regs.a[2]);
    NewValueDlg->Address->Text=str;
    NewValueDlg->Address->SelectAll();
    NewValueDlg->ActiveControl=NewValueDlg->Address;
    if (NewValueDlg->ShowModal()==1)
    {
        sscanf(NewValueDlg->Address->Text.c_str(),"%x",
            &regs.a[2]);
        Update();
    }
}
//---------------------------------------------------------------------------

void __fastcall TDebugWnd::A3Click(TObject *Sender)
{
    char str[4];
    sprintf(str,"%8.8X",regs.a[3]);
    NewValueDlg->Address->Text=str;
    NewValueDlg->Address->SelectAll();
    NewValueDlg->ActiveControl=NewValueDlg->Address;
    if (NewValueDlg->ShowModal()==1)
    {
        sscanf(NewValueDlg->Address->Text.c_str(),"%x",
            &regs.a[3]);
        Update();
    }
}
//---------------------------------------------------------------------------

void __fastcall TDebugWnd::A4Click(TObject *Sender)
{
    char str[4];
    sprintf(str,"%8.8X",regs.a[4]);
    NewValueDlg->Address->Text=str;
    NewValueDlg->Address->SelectAll();
    NewValueDlg->ActiveControl=NewValueDlg->Address;
    if (NewValueDlg->ShowModal()==1)
    {
        sscanf(NewValueDlg->Address->Text.c_str(),"%x",
            &regs.a[4]);
        Update();
    }
}
//---------------------------------------------------------------------------

void __fastcall TDebugWnd::A5Click(TObject *Sender)
{
    char str[4];
    sprintf(str,"%8.8X",regs.a[5]);
    NewValueDlg->Address->Text=str;
    NewValueDlg->Address->SelectAll();
    NewValueDlg->ActiveControl=NewValueDlg->Address;
    if (NewValueDlg->ShowModal()==1)
    {
        sscanf(NewValueDlg->Address->Text.c_str(),"%x",
            &regs.a[5]);
        Update();
    }
}
//---------------------------------------------------------------------------

void __fastcall TDebugWnd::A6Click(TObject *Sender)
{
    char str[4];
    sprintf(str,"%8.8X",regs.a[6]);
    NewValueDlg->Address->Text=str;
    NewValueDlg->Address->SelectAll();
    NewValueDlg->ActiveControl=NewValueDlg->Address;
    if (NewValueDlg->ShowModal()==1)
    {
        sscanf(NewValueDlg->Address->Text.c_str(),"%x",
            &regs.a[6]);
        Update();
    }
}
//---------------------------------------------------------------------------

void __fastcall TDebugWnd::A7Click(TObject *Sender)
{
    char str[4];
    sprintf(str,"%8.8X",regs.a[7]);
    NewValueDlg->Address->Text=str;
    NewValueDlg->Address->SelectAll();
    NewValueDlg->ActiveControl=NewValueDlg->Address;
    if (NewValueDlg->ShowModal()==1)
    {
        sscanf(NewValueDlg->Address->Text.c_str(),"%x",
            &regs.a[7]);
        Update();
    }
}
//---------------------------------------------------------------------------

void __fastcall TDebugWnd::PCClick(TObject *Sender)
{
    char str[4];
    sprintf(str,"%6.6X",regs.pc);
    NewValueDlg->Address->Text=str;
    NewValueDlg->Address->SelectAll();
    NewValueDlg->ActiveControl=NewValueDlg->Address;
    if (NewValueDlg->ShowModal()==1)
    {
        sscanf(NewValueDlg->Address->Text.c_str(),"%x",
            &regs.pc);
        debugStartPC=regs.pc;
        Update();
    }
}
//---------------------------------------------------------------------------

void __fastcall TDebugWnd::SRClick(TObject *Sender)
{
    char str[4];
    MakeSR();
    sprintf(str,"%4.4X",regs.sr);
    NewValueDlg->Address->Text=str;
    NewValueDlg->Address->SelectAll();
    NewValueDlg->ActiveControl=NewValueDlg->Address;
    if (NewValueDlg->ShowModal()==1)
    {
        int v;
        sscanf(NewValueDlg->Address->Text.c_str(),"%x",&v);
        regs.sr=v&0xffff;
        MakeFromSR();
        Update();
    }
}
//---------------------------------------------------------------------------

void __fastcall TDebugWnd::TFlagClick(TObject *Sender)
{
    char str[4];
    sprintf(str,"%1.1X",(regs.t1<<1)+regs.t0);
    NewValueDlg->Address->Text=str;
    NewValueDlg->Address->SelectAll();
    NewValueDlg->ActiveControl=NewValueDlg->Address;
    if (NewValueDlg->ShowModal()==1)
    {
        int v;
        sscanf(NewValueDlg->Address->Text.c_str(),"%x",&v);
        regs.t1=v&2; regs.t0=v&1;
        Update();
    }
}
//---------------------------------------------------------------------------

void __fastcall TDebugWnd::SFlagClick(TObject *Sender)
{
    char str[4];
    sprintf(str,"%1.1X",regs.s);
    NewValueDlg->Address->Text=str;
    NewValueDlg->Address->SelectAll();
    NewValueDlg->ActiveControl=NewValueDlg->Address;
    if (NewValueDlg->ShowModal()==1)
    {
        int v;
        sscanf(NewValueDlg->Address->Text.c_str(),"%x",&v);
        regs.s=v&1;
        Update();
    }
}
//---------------------------------------------------------------------------

void __fastcall TDebugWnd::MFlagClick(TObject *Sender)
{
    char str[4];
    sprintf(str,"%1.1X",regs.m);
    NewValueDlg->Address->Text=str;
    NewValueDlg->Address->SelectAll();
    NewValueDlg->ActiveControl=NewValueDlg->Address;
    if (NewValueDlg->ShowModal()==1)
    {
        int v;
        sscanf(NewValueDlg->Address->Text.c_str(),"%x",&v);
        regs.m=v&1;
        Update();
    }
}
//---------------------------------------------------------------------------

void __fastcall TDebugWnd::IFlagClick(TObject *Sender)
{
    char str[4];
    sprintf(str,"%1.1X",regs.intmask);
    NewValueDlg->Address->Text=str;
    NewValueDlg->Address->SelectAll();
    NewValueDlg->ActiveControl=NewValueDlg->Address;
    if (NewValueDlg->ShowModal()==1)
    {
        int v;
        sscanf(NewValueDlg->Address->Text.c_str(),"%x",&v);
        regs.intmask=v&7;
        Update();
    }
}
//---------------------------------------------------------------------------

void __fastcall TDebugWnd::XFlagClick(TObject *Sender)
{
    char str[4];
    sprintf(str,"%1.1X",regs.x);
    NewValueDlg->Address->Text=str;
    NewValueDlg->Address->SelectAll();
    NewValueDlg->ActiveControl=NewValueDlg->Address;
    if (NewValueDlg->ShowModal()==1)
    {
        int v;
        sscanf(NewValueDlg->Address->Text.c_str(),"%x",&v);
        regs.x=v&1;
        Update();
    }
}
//---------------------------------------------------------------------------

void __fastcall TDebugWnd::NFlagClick(TObject *Sender)
{
    char str[4];
    sprintf(str,"%1.1X",NFLG);
    NewValueDlg->Address->Text=str;
    NewValueDlg->Address->SelectAll();
    NewValueDlg->ActiveControl=NewValueDlg->Address;
    if (NewValueDlg->ShowModal()==1)
    {
        int v;
        sscanf(NewValueDlg->Address->Text.c_str(),"%x",&v);
        NFLG=v&1;
        Update();
    }
}
//---------------------------------------------------------------------------

void __fastcall TDebugWnd::ZFlagClick(TObject *Sender)
{
    char str[4];
    sprintf(str,"%1.1X",ZFLG);
    NewValueDlg->Address->Text=str;
    NewValueDlg->Address->SelectAll();
    NewValueDlg->ActiveControl=NewValueDlg->Address;
    if (NewValueDlg->ShowModal()==1)
    {
        int v;
        sscanf(NewValueDlg->Address->Text.c_str(),"%x",&v);
        ZFLG=v&1;
        Update();
    }
}
//---------------------------------------------------------------------------

void __fastcall TDebugWnd::VFlagClick(TObject *Sender)
{
    char str[4];
    sprintf(str,"%1.1X",VFLG);
    NewValueDlg->Address->Text=str;
    NewValueDlg->Address->SelectAll();
    NewValueDlg->ActiveControl=NewValueDlg->Address;
    if (NewValueDlg->ShowModal()==1)
    {
        int v;
        sscanf(NewValueDlg->Address->Text.c_str(),"%x",&v);
        VFLG=v&1;
        Update();
    }
}
//---------------------------------------------------------------------------

void __fastcall TDebugWnd::CFlagClick(TObject *Sender)
{
    char str[4];
    sprintf(str,"%1.1X",CFLG);
    NewValueDlg->Address->Text=str;
    NewValueDlg->Address->SelectAll();
    NewValueDlg->ActiveControl=NewValueDlg->Address;
    if (NewValueDlg->ShowModal()==1)
    {
        int v;
        sscanf(NewValueDlg->Address->Text.c_str(),"%x",&v);
        CFLG=v&1;
        Update();
    }
}
//---------------------------------------------------------------------------

void __fastcall TDebugWnd::Viewlog1Click(TObject *Sender)
{
    LogDlg->ShowModal();
    Enablelogging1->Checked=debugLogEnable;
    if ((debugLogEnable&&debugLogCount)||debugDataBreakCount)
        UseDebugReadFuncs();
    else
        RestoreReadFuncs();
}
//---------------------------------------------------------------------------

void __fastcall TDebugWnd::Editloggedaddresses1Click(TObject *Sender)
{
    EditLogDlg->UpdateList();
    EditLogDlg->ShowModal();
    Enablelogging1->Checked=debugLogEnable;
    if ((debugLogEnable&&debugLogCount)||debugDataBreakCount)
        UseDebugReadFuncs();
    else
        RestoreReadFuncs();
}
//---------------------------------------------------------------------------

void __fastcall TDebugWnd::Enablelogging1Click(TObject *Sender)
{
    debugLogEnable=!debugLogEnable;
    Enablelogging1->Checked=debugLogEnable;
    if ((debugLogEnable&&debugLogCount)||debugDataBreakCount)
        UseDebugReadFuncs();
    else
        RestoreReadFuncs();
}
//---------------------------------------------------------------------------

void __fastcall TDebugWnd::Clearall1Click(TObject *Sender)
{
    debugLogEnable=0;
    Enablelogging1->Checked=false;
    debugLogCount=0;
    if ((debugLogEnable&&debugLogCount)||debugDataBreakCount)
        UseDebugReadFuncs();
    else
        RestoreReadFuncs();
}
//---------------------------------------------------------------------------

void __fastcall TDebugWnd::Loglinkportsend1Click(TObject *Sender)
{
    Loglinkportsend1->Checked=!Loglinkportsend1->Checked;
    debugLogLinkSend=Loglinkportsend1->Checked;
}
//---------------------------------------------------------------------------

void __fastcall TDebugWnd::Loglinkportreceive1Click(TObject *Sender)
{
    Loglinkportreceive1->Checked=!Loglinkportreceive1->Checked;
    debugLogLinkRecv=Loglinkportreceive1->Checked;
}
//---------------------------------------------------------------------------

