//---------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Entry.h"
#define NOTYPEREDEF
#include "cpudefs.h"
//---------------------------------------------------------------------
#pragma resource "*.dfm"

#define ROMTBL(x) readmem24_dword(cpu_readmem24_dword(0xc8)+(x)*4)
#define HANDLE_TABLE readmem24_dword(ROMTBL(0x2f)+0x11a)
#define HANDLE(x) readmem24_dword(HANDLE_TABLE+4*(x))
#define GETBYTE(x) (readmem24(x)&0xff)
#define GETWORD(x) (readmem24_word(x)&0xffff)

TProgramEntryDlg *ProgramEntryDlg;
extern int debugProgBreak;
//---------------------------------------------------------------------
__fastcall TProgramEntryDlg::TProgramEntryDlg(TComponent* AOwner)
	: TForm(AOwner)
{
}
//---------------------------------------------------------------------
void __fastcall TProgramEntryDlg::UpdateTree()
{
    Programs->Items->Clear();
    int addr=HANDLE(8)+4;
    char name[10];
    for (int i=0;i<GETWORD(addr-2);i++)
    {
        int j;
        for (j=0;j<9;j++)
        {
            name[j]=GETBYTE(addr+14*i+j);
            if ((name[j]<=' ')&&(name[j]))
                return;
        }
        TTreeNode *p=Programs->Items->AddChild(NULL,name);
        p->Data=NULL;
        int fa=HANDLE(GETWORD(addr+14*i+12))+4;
        for (int k=0;k<GETWORD(fa-2);k++)
        {
            for (j=0;j<9;j++)
            {
                name[j]=GETBYTE(fa+14*k+j);
                if ((name[j]<=' ')&&(name[j]))
                    return;
            }
            int pa=HANDLE(GETWORD(fa+14*k+12));
            pa+=1+GETWORD(pa);
            if (GETBYTE(pa)==0xf3)
            {
                TTreeNode *tn=Programs->Items->AddChild(p,
                    name);
                int handle=GETWORD(fa+14*k+12);
                tn->Data=(void*)((2<<16)+handle);
                if ((HANDLE_TABLE+(handle<<2))==debugProgBreak)
                    Programs->Selected=tn;
            }
        }
    }
    Programs->FullExpand();
}



void __fastcall TProgramEntryDlg::OKBtnClick(TObject *Sender)
{
    ModalResult=1;    
}
//---------------------------------------------------------------------------

void __fastcall TProgramEntryDlg::CancelBtnClick(TObject *Sender)
{
    ModalResult=2;    
}
//---------------------------------------------------------------------------

