//---------------------------------------------------------------------------
#include <vcl.h>
#include <vcl\registry.hpp>
#include <stdio.h>
#pragma hdrstop
USERES("VTi68k.res");
USEFORM("Emu92.cpp", Emu92Wnd);
USEUNIT("emu.cpp");
USELIB("..\..\CBuilder3\Lib\dinput.lib");
USEFORM("Debug.cpp", DebugWnd);
USEUNIT("m68kdasm.cpp");
USEFORM("gotodialog.cpp", GoToDlg);
USEFORM("About.cpp", AboutDlg);
USEFORM("EmuMode.cpp", EmuModeDlg);
USEFORM("Value.cpp", NewValueDlg);
USEFORM("Entry.cpp", ProgramEntryDlg);
USEFORM("Data.cpp", DataBreakDlg);
USEFORM("AddData.cpp", AddDataBreakDlg);
USEFORM("Search.cpp", SearchDlg);
USEFORM("AddLog.cpp", AddLogDlg);
USEFORM("Log.cpp", LogDlg);
USEFORM("EditLog.cpp", EditLogDlg);
USEFORM("Start.cpp", StartWnd);
USEUNIT("asmintf.cpp");
USEUNIT("opcodee.cpp");
USEUNIT("opcode1.cpp");
USEUNIT("opcode2.cpp");
USEUNIT("opcode3.cpp");
USEUNIT("opcode4.cpp");
USEUNIT("opcode5.cpp");
USEUNIT("opcode6.cpp");
USEUNIT("opcode7.cpp");
USEUNIT("opcode8.cpp");
USEUNIT("opcode9.cpp");
USEUNIT("opcodeb.cpp");
USEUNIT("opcodec.cpp");
USEUNIT("opcoded.cpp");
USEUNIT("opcode0.cpp");
USEUNIT("cpufunc.cpp");
USEUNIT("link.cpp");
USEFORM("LinkType.cpp", LinkTypeDialog);
USEUNIT("Dump.cpp");
USEFORM("Dumpwnd.cpp", DumpWindow);
USEFORM("Redef.cpp", RedefineWnd);
//---------------------------------------------------------------------------
#include "Start.h"
#include "Debug.h"
#define NOTYPEREDEF
#include "cpudefs.h"
#include "linktype.h"
#include "dumpwnd.h"
#include "dump.h"
//---------------------------------------------------------------------------
extern int InitEmu(int mode);
extern int AnalyzeROMs();
extern void LoadState(char *name);
extern int calc,plusMod,debug,run,debugStartPC;
extern struct
{
    char file[32];
    char name[64];
    int type;
    int version;
    int size;
} romImage[64];
extern int romImageCount;

int DumpROM();
extern int SendFile(int port);

extern bool restrict;

enum keys {kn,k_f1,k_f2,k_f3,k_f4,k_f5,k_f6,k_f7,k_f8,k_hand,
    k_q,k_w,k_e,k_r,k_t,k_y,k_u,k_i,k_o,k_p,k_a,k_s,k_d,k_f,
    k_g,k_h,k_j,k_k,k_l,k_z,k_x,k_c,k_v,k_b,k_n,k_m,k_shift,
    k_theta,k_dia,k_2nd,k_sto,k_space,k_equ,k_bs,k_enter1,
    k_esc,k_mode,k_clear,k_ln,k_sin,k_cos,k_tan,k_power,
    k_apps,k_enter2,k_up,k_down,k_left,k_right,k_lparan,
    k_rparan,k_comma,k_div,k_7,k_8,k_9,k_mult,k_4,k_5,k_6,
    k_minus,k_1,k_2,k_3,k_plus,k_0,k_dot,k_neg,k_on};
extern int keymap[];
extern char* alphakeystr[];
//---------------------------------------------------------------------------
HINSTANCE hInst;
WINAPI WinMain(HINSTANCE inst, HINSTANCE, LPSTR, int)
{
    hInst=inst;
    try
    {
        Application->Initialize();
        Application->Title = "Virtual TI-89/92(+)";
        {
            StartWnd=new TStartWnd(NULL);
            StartWnd->Show();
            StartWnd->Update();
            int rn=AnalyzeROMs();
            StartWnd->Message->Caption="Loading ROM image...";
            StartWnd->Message->Update();
            TRegistry *reg=new TRegistry;
            reg->RootKey=HKEY_LOCAL_MACHINE;
            reg->OpenKey("\\Software\\PlusShell",true);
            if (reg->ValueExists("LastEmuROM"))
            {
                AnsiString str=reg->ReadString("LastEmuROM");
                int i;
                for (i=0;i<romImageCount;i++)
                {
                    if (!strcmp(str.c_str(),romImage[i].name))
                        rn=i;
                }
            }
            if (reg->ValueExists("RestrictSpeed"))
                restrict=reg->ReadInteger("RestrictSpeed");
            if (reg->OpenKey("EmuKeyMap",false))
            {
                for (int i=k_q;i<=k_m;i++)
                {
                    int j;
                    for (j=0;keymap[j]!=-1;j+=2)
                    {
                        if (keymap[j+1]==i)
                        {
                            char str[4];
                            sprintf(str,"%s",alphakeystr[i-k_q]);
                            if (reg->ValueExists(str))
                                keymap[j]=reg->ReadInteger(str);
                            break;
                        }
                    }
                }
            }
            reg->CloseKey();
            delete reg;
            if (rn==-1)
            {
                StartWnd->Hide();
                if (MessageBox(NULL,"Could not find ROM image.  Do you want to obtain\n"
                    "one from your calculator now (takes ~45 minutes)?","Error",
                    MB_YESNO|MB_ICONQUESTION)==IDYES)
                {
                    if (DumpROM())
                    {
                        StartWnd->Show();
                        StartWnd->Update();
                        rn=AnalyzeROMs();
                        StartWnd->Message->Caption="Loading ROM image...";
                        StartWnd->Message->Update();
                        if (rn==-1)
                        {
                            StartWnd->Hide();
                            MessageBox(NULL,"Could not load ROM","Error",
                                MB_OK|MB_ICONSTOP);
                            return 1;
                        }
                    }
                    else
                        return 1;
                }
                else
                    return 1;
            }
            int c=InitEmu(rn);
            StartWnd->Hide();
            LoadState(NULL);
        }
        Application->CreateForm(__classid(TEmu92Wnd), &Emu92Wnd);
        Application->CreateForm(__classid(TDebugWnd), &DebugWnd);
        Application->CreateForm(__classid(TGoToDlg), &GoToDlg);
        Application->CreateForm(__classid(TAboutDlg), &AboutDlg);
        Application->CreateForm(__classid(TEmuModeDlg), &EmuModeDlg);
        Application->CreateForm(__classid(TNewValueDlg), &NewValueDlg);
        Application->CreateForm(__classid(TProgramEntryDlg), &ProgramEntryDlg);
        Application->CreateForm(__classid(TDataBreakDlg), &DataBreakDlg);
        Application->CreateForm(__classid(TAddDataBreakDlg), &AddDataBreakDlg);
        Application->CreateForm(__classid(TSearchDlg), &SearchDlg);
        Application->CreateForm(__classid(TAddLogDlg), &AddLogDlg);
        Application->CreateForm(__classid(TLogDlg), &LogDlg);
        Application->CreateForm(__classid(TEditLogDlg), &EditLogDlg);
        Application->CreateForm(__classid(TDumpWindow), &DumpWindow);
        Application->CreateForm(__classid(TRedefineWnd), &RedefineWnd);
        Application->Run();
    }
    catch (Sysutils::Exception &exception)
    {
        Application->ShowException(&exception);
    }
    return 0;
}
//---------------------------------------------------------------------------
extern void clInitCom(int n,int timeout=0);
extern void clCloseCom();
extern void clSendCom(int ch);
extern int clGetCom(int &ch);
extern int clGetError();
extern void clResetError();
extern int dumpCancel,dumpComplete,dumpSuccess;
int DumpROM()
{
    TLinkTypeDialog *dlog=new TLinkTypeDialog(NULL);
    if (dlog->ShowModal()==mrCancel)
    {
        delete dlog;
        return 0;
    }
    int com=1;
    if (dlog->COM1->Checked) com=1;
    else if (dlog->COM2->Checked) com=2;
    else if (dlog->COM3->Checked) com=3;
    else if (dlog->COM4->Checked) com=4;
    delete dlog;
    if (MessageBox(NULL,"The ROM dump program will now be transferred to your\n"
        "calculator.  Make sure it is on and at the home screen.\n",
        "ROM Dump",MB_OKCANCEL|MB_ICONINFORMATION)==IDOK)
    {
        if (SendFile(com))
        {
            MessageBox(NULL,"Could not send file to calculator",
                "Error",MB_OK|MB_ICONSTOP);
            return 0;
        }
        if (MessageBox(NULL,"If it doesn't start automatically, start the\n"
            "ROM dump program by running dumprom() at the\n"
            "calculator's home screen after clicking OK.\n",
            "ROM Dump",MB_OKCANCEL|MB_ICONINFORMATION)==IDOK)
        {
            int ch;
            clInitCom(com,1000);
            clSendCom(9); clSendCom(0x87);
            clSendCom(7); clSendCom(1);
            clGetCom(ch); clGetCom(ch);
            clGetCom(ch); clGetCom(ch);
            clSendCom(9); clSendCom(0x87);
            clSendCom(7); clSendCom(1);
            clGetCom(ch); clGetCom(ch);
            clGetCom(ch); clGetCom(ch);
            clSendCom(9); clSendCom(0x87);
            clSendCom('m'); clSendCom(0);
            clGetCom(ch); clGetCom(ch);
            clGetCom(ch); clGetCom(ch);
            clSendCom(9); clSendCom(0x87);
            clSendCom('a'); clSendCom(0);
            clGetCom(ch); clGetCom(ch);
            clGetCom(ch); clGetCom(ch);
            clSendCom(9); clSendCom(0x87);
            clSendCom('i'); clSendCom(0);
            clGetCom(ch); clGetCom(ch);
            clGetCom(ch); clGetCom(ch);
            clSendCom(9); clSendCom(0x87);
            clSendCom('n'); clSendCom(0);
            clGetCom(ch); clGetCom(ch);
            clGetCom(ch); clGetCom(ch);
            clSendCom(9); clSendCom(0x87);
            clSendCom('\\'); clSendCom(0);
            clGetCom(ch); clGetCom(ch);
            clGetCom(ch); clGetCom(ch);
            clSendCom(9); clSendCom(0x87);
            clSendCom('d'); clSendCom(0);
            clGetCom(ch); clGetCom(ch);
            clGetCom(ch); clGetCom(ch);
            clSendCom(9); clSendCom(0x87);
            clSendCom('u'); clSendCom(0);
            clGetCom(ch); clGetCom(ch);
            clGetCom(ch); clGetCom(ch);
            clSendCom(9); clSendCom(0x87);
            clSendCom('m'); clSendCom(0);
            clGetCom(ch); clGetCom(ch);
            clGetCom(ch); clGetCom(ch);
            clSendCom(9); clSendCom(0x87);
            clSendCom('p'); clSendCom(0);
            clGetCom(ch); clGetCom(ch);
            clGetCom(ch); clGetCom(ch);
            clSendCom(9); clSendCom(0x87);
            clSendCom('r'); clSendCom(0);
            clGetCom(ch); clGetCom(ch);
            clGetCom(ch); clGetCom(ch);
            clSendCom(9); clSendCom(0x87);
            clSendCom('o'); clSendCom(0);
            clGetCom(ch); clGetCom(ch);
            clGetCom(ch); clGetCom(ch);
            clSendCom(9); clSendCom(0x87);
            clSendCom('m'); clSendCom(0);
            clGetCom(ch); clGetCom(ch);
            clGetCom(ch); clGetCom(ch);
            clSendCom(9); clSendCom(0x87);
            clSendCom('('); clSendCom(0);
            clGetCom(ch); clGetCom(ch);
            clGetCom(ch); clGetCom(ch);
            clSendCom(9); clSendCom(0x87);
            clSendCom(')'); clSendCom(0);
            clGetCom(ch); clGetCom(ch);
            clGetCom(ch); clGetCom(ch);
            clSendCom(9); clSendCom(0x87);
            clSendCom(13); clSendCom(0);
            clGetCom(ch); clGetCom(ch);
            clGetCom(ch); clGetCom(ch);
            clCloseCom();
            dumpCancel=0; dumpComplete=0; dumpSuccess=0;
            DumpWindow=new TDumpWindow(NULL);
            DumpWindow->ProgressBar1->Position=0;
            DumpWindow->Label1->Caption="Waiting to receive ROM...";
            DumpWindow->Show();
            new DumpThread(com,false);
            while (!dumpComplete)
                Application->ProcessMessages();
            DumpWindow->Close();
            delete DumpWindow;
            DumpWindow=NULL;
            return dumpSuccess;
        }
    }
    return 0;
}

