#include <windows.h>
#define NOTYPEREDEF
#include "cpudefs.h"
#include "video.h"
#include "M68000.h"
#include "Log.h"
#include <stdio.h>
#include <string.h>
#include <dir.h>
#include <io.h>
#include <dos.h>

#define DATABREAK_READ 1
#define DATABREAK_WRITE 2
#define DATABREAK_BOTH 3

#define LOG_VALUE 1
#define LOG_BIT 2

BYTE *ram,*intRom,*extRom,*origRom;
int initialPC;
int contrast,memprotect,ram128,timer,timerInit,int0Count;
int io0Bit7,io0Bit2;
int kbmask,ramWrap,memAnd,onheld;
int lcdBase,lcdRefresh,lcdWidth,lcdHeight;
int kbmatrix[10];
int calc,intRom92,plusMod,ramSize;
int rom92Present,rom92PlusPresent,rom89Present;
int initIntTabOfs;
int ExitEmulator,TransferState;
int comError,transflag,transbyte,transnotready;
int recvflag,recvbyte;
int romWriteReady,romWritePhase,romRetOr;
int romErase,romErasePhase;
int romChanged[32];
BYTE oldScreen[6][3840];
int oldScreenBase[6];
int scrNum=0;
char *ScreenLine[128];
extern int run;
int needPath=1;
char initPath[256];
int lcdOff;

extern int cpuCompleteStop;
extern int debugLogLinkSend,debugLogLinkRecv;
extern int pending_interrupts;

#define ROMFLAG_TI89 1
#define ROMFLAG_INTERNAL 2
#define ROMFLAG_UPDATE 4
#define ROMFLAG_FLASHROM 8
#define ROMFLAG_SPECIAL 16

struct
{
    char file[32];
    char name[64];
    int type;
    int version;
    int size;
} romImage[64];
int romImageCount;
int currentROM;
int latestPlusROM;
int latest89ROM;

readmem_func *ReadByte[16]={ReadRAMByte,
    ReadRAMByte,ReadIntROMByte,ReadIntROMByte,
    ReadExtROMByte,ReadExtROMByte,ReadIOByte,
    ReadIOByte,ReadRAMByte,ReadRAMByte,ReadIntROMByte,
    ReadIntROMByte,ReadExtROMByte,ReadExtROMByte,
    ReadIOByte,ReadIOByte};

readmem_func *ReadWord[16]={ReadRAMWord,
    ReadRAMWord,ReadIntROMWord,ReadIntROMWord,
    ReadExtROMWord,ReadExtROMWord,ReadIOWord,
    ReadIOWord,ReadRAMWord,ReadRAMWord,ReadIntROMWord,
    ReadIntROMWord,ReadExtROMWord,ReadExtROMWord,
    ReadIOWord,ReadIOWord};

readmem_func *ReadDWord[16]={ReadRAMDWord,
    ReadRAMDWord,ReadIntROMDWord,ReadIntROMDWord,
    ReadExtROMDWord,ReadExtROMDWord,ReadIODWord,
    ReadIODWord,ReadRAMDWord,ReadRAMDWord,ReadIntROMDWord,
    ReadIntROMDWord,ReadExtROMDWord,ReadExtROMDWord,
    ReadIODWord,ReadIODWord};

struct
{
    int num;
    char *name;
} romFuncs[]={0xe3,"tios::ST_eraseHelp",0xe6,
    "tios::ST_showHelp",0x97,"tios::HeapFree",
    0x90,"tios::HeapAlloc",0x154,"tios::ER_catch",
    0x155,"tios::ER_success",0x24c,"tios::reset_link",
    0x24d,"tios::flush_link",0x252,"tios::tx_free",
    0x250,"tios::transmit",0x24f,"tios::receive",
    0x98,"tios::HeapFreeIndir",0xe2,"tios::ST_busy",
    0x153,"tios::ER_throwVar",0x9d,"tios::HeapRealloc",
    0x53,"tios::sprintf",0x1a9,"tios::DrawStrXY",
    0x18f,"tios::FontSetSys",0x19c,"tios::DrawTo",
    0x19d,"tios::MoveTo",0x1a2,"tios::PortSet",
    0x1a3,"tios::PortRestore",0x1,"tios::WinActivate",
    0xb,"tios::WinClose",0x1e,"tios::WinOpen",
    0x26,"tios::WinStrXY",0x3b,"tios::MenuPopup",
    0x36,"tios::MenuBegin",0x3a,"tios::MenuOn",
    0x93,"tios::HeapAllocThrow",0x271,"tios::strcmp",
    0x18e,"tios::FontGetSys",0x27e,"tios::strlen",
    0x272,"tios::strncmp",0x26d,"tios::strncpy",
    0x26e,"tios::strcat",0x274,"tios::strchr",
    0x151,"tios::ERD_dialog",0x27c,"tios::memset",
    0x270,"tios::memcmp",0x26a,"tios::memcpy",
    0x26b,"tios::memmove",0x2aa,"tios::_du32u32",
    0x2a8,"tios::_ds32s32",0x2a6,"tios::_du16u16",
    0x2a4,"tios::_ds16u16",0x2ab,"tios::_ru32u32",
    0x2a9,"tios::_rs32s32",0x2a7,"tios::_ru16u16",
    0x2a5,"tios::_rs16u16",0x79,"tios::DerefSym",
    0,NULL};
int romFuncAddr[512];

int irv[7],igv[7],ibv[7];

int irv89[7]={49,100,126,152,178,204,237};
int igv89[7]={46,100,126,152,178,204,245};
int ibv89[7]={34,107,132,157,182,207,223};

int irv92[7]={83,109,135,161,187,213,239};
int igv92[7]={111,134,158,181,204,228,251};
int ibv92[7]={138,153,168,183,197,212,227};

int contrastDelta[8]={0,-2,-4,-7,-10,-7,-4,-2};

extern int pending_interrupts;
extern unsigned char *ScreenBuf;

void DoInstruction();

void IRQ(int level)
{
    if (cpuCompleteStop&&(level==6))
    {
        cpuCompleteStop=0;
        return;
    }
    MC68000_Cause_Interrupt(level);
//	pending_interrupts|=1<<(level+24);
}

void FillROMAddrs(int rta)
{
    for (int i=0;romFuncs[i].num;i++)
        romFuncAddr[i]=readmem24_dword(rta+(romFuncs[i].num<<2));
}

int inline IsNum(char c)
{
    if ((c>='0')&&(c<='9'))
        return 1;
    return 0;
}

int inline IsAlNum(char c)
{
    if ((c>='0')&&(c<='9'))
        return 1;
    if ((c>='a')&&(c<='z'))
        return 1;
    if ((c>='A')&&(c<='Z'))
        return 1;
    if (c==' ')
        return 1;
    return 0;
}

void AddROM(char *name,int size)
{
    if ((size!=(1024*1024))&&(size!=(2048*1024)))
        return;
    FILE *fp=fopen(name,"rb");
    if (!fp) return;
    char *buf=new char[size];
    fread(buf,size,1,fp);
    int ver=0;
    int flags=0;
    if ((buf[5]&0x60)==0x20) flags|=ROMFLAG_INTERNAL;
    if (!(buf[0x65]&0xf)) flags|=ROMFLAG_FLASHROM;
    if ((flags&ROMFLAG_INTERNAL)&&(flags&ROMFLAG_FLASHROM))
        flags|=ROMFLAG_TI89;
    for (int i=0;i<size-16;i+=2)
    {
        if (IsNum(buf[i])&&(buf[i+1]=='.')&&IsNum(buf[i+2])&&
            (buf[i+3]==0)&&IsAlNum(buf[i+4])&&IsAlNum(buf[i+5])&&
            IsAlNum(buf[i+7])&&IsAlNum(buf[i+8])&&
            IsAlNum(buf[i+10])&&IsAlNum(buf[i+11]))
        {
            ver=i;
            break;
        }
        if (IsNum(buf[i])&&(buf[i+1]=='.')&&IsNum(buf[i+2])&&
            IsNum(buf[i+3])&&(buf[i+4]==0)&&IsAlNum(buf[i+5])&&
            IsAlNum(buf[i+6])&&IsAlNum(buf[i+8])&&
            IsAlNum(buf[i+9])&&IsAlNum(buf[i+11])&&
            IsAlNum(buf[i+12]))
        {
            ver=i;
            break;
        }
    }
    if (ver)
    {
        strcpy(romImage[romImageCount].file,name);
        if (flags&ROMFLAG_TI89)
        {
            sprintf(romImage[romImageCount].name,
                "TI-89 version %s",&buf[ver]);
        }
        else
        {
            if (flags&ROMFLAG_FLASHROM)
            {
                sprintf(romImage[romImageCount].name,
                    "TI-92 Plus version %s",&buf[ver]);
            }
            else
            {
                if (flags&ROMFLAG_INTERNAL)
                {
                    sprintf(romImage[romImageCount].name,
                        "TI-92 version %s (internal)",&buf[ver]);
                }
                else
                {
                    sprintf(romImage[romImageCount].name,
                        "TI-92 version %s (external)",&buf[ver]);
                }
            }
        }
        romImage[romImageCount].type=flags;
        if (buf[ver+3]==0)
            ver=(buf[ver]<<16)+buf[ver+2];
        else
            ver=(buf[ver]<<16)+(buf[ver+2]<<8)+buf[ver+3];
        romImage[romImageCount].version=ver;
        romImage[romImageCount].size=size;
        romImageCount++;
    }
    delete[] buf;
    fclose(fp);
}

void AddROMUpdate(char *name,int size)
{
    FILE *fp=fopen(name,"rb");
    if (!fp) return;
    char *buf=new char[size];
    fread(buf,size,1,fp);
    int ver=0;
    int flags=ROMFLAG_UPDATE|ROMFLAG_FLASHROM;
    if ((buf[0x8d]&0x60)==0x20)
        flags|=ROMFLAG_INTERNAL|ROMFLAG_TI89;
    if (!strncmp(&buf[0x16],"Advanced Mathematics Software",29))
    {
       for (int i=0;i<size-16;i+=2)
       {
            if (IsNum(buf[i])&&(buf[i+1]=='.')&&IsNum(buf[i+2])&&
                (buf[i+3]==0)&&IsAlNum(buf[i+4])&&IsAlNum(buf[i+5])&&
                IsAlNum(buf[i+7])&&IsAlNum(buf[i+8])&&
                IsAlNum(buf[i+10])&&IsAlNum(buf[i+11]))
            {
                ver=i;
                break;
            }
            if (IsNum(buf[i])&&(buf[i+1]=='.')&&IsNum(buf[i+2])&&
                IsNum(buf[i+3])&&(buf[i+4]==0)&&IsAlNum(buf[i+5])&&
                IsAlNum(buf[i+6])&&IsAlNum(buf[i+8])&&
                IsAlNum(buf[i+9])&&IsAlNum(buf[i+11])&&
                IsAlNum(buf[i+12]))
            {
                ver=i;
                break;
            }
        }
    }
    else
    {
        flags|=ROMFLAG_SPECIAL;
        ver=-1;
    }
    if (ver)
    {
        strcpy(romImage[romImageCount].file,name);
        if (flags&ROMFLAG_SPECIAL)
        {
            if (flags&ROMFLAG_TI89)
            {
                buf[0x16+buf[0x15]]=0;
                sprintf(romImage[romImageCount].name,
                    "%s (TI-89)",&buf[0x16]);
            }
            else
            {
                buf[0x16+buf[0x15]]=0;
                sprintf(romImage[romImageCount].name,
                    "%s (TI-92 Plus)",&buf[0x16]);
            }
        }
        else if (flags&ROMFLAG_TI89)
        {
            sprintf(romImage[romImageCount].name,
                "TI-89 version %s (update)",&buf[ver]);
        }
        else
        {
            sprintf(romImage[romImageCount].name,
                "TI-92 Plus version %s (update)",&buf[ver]);
        }
        romImage[romImageCount].type=flags;
        if (ver!=-1)
        {
            if (buf[ver+3]==0)
                ver=(buf[ver]<<16)+buf[ver+2];
            else
                ver=(buf[ver]<<16)+(buf[ver+2]<<8)+buf[ver+3];
        }
        romImage[romImageCount].version=ver;
        romImage[romImageCount].size=size;
        romImageCount++;
    }
    delete[] buf;
    fclose(fp);
}

int AnalyzeROMs()
{
    ffblk ff;
    int done,i,use,type,ver,ver89,verPlus;

    romImageCount=0;
    done=findfirst("*.rom",&ff,FA_RDONLY|FA_ARCH);
    while (!done)
    {
        AddROM(ff.ff_name,ff.ff_fsize);
        done=findnext(&ff);
    }
    done=findfirst("*.dmp",&ff,FA_RDONLY|FA_ARCH);
    while (!done)
    {
        AddROM(ff.ff_name,ff.ff_fsize);
        done=findnext(&ff);
    }
    done=findfirst("*.tib",&ff,FA_RDONLY|FA_ARCH);
    while (!done)
    {
        AddROMUpdate(ff.ff_name,ff.ff_fsize);
        done=findnext(&ff);
    }
    if (!romImageCount) return -1;
    use=0; type=romImage[0].type; ver=romImage[0].version;
    latestPlusROM=-1; latest89ROM=-1;
    ver89=0; verPlus=0;
    for (i=0;i<romImageCount;i++)
    {
        if ((romImage[i].type&ROMFLAG_FLASHROM)&&
            (!(romImage[i].type&ROMFLAG_UPDATE)))
        {
            if (romImage[i].type&ROMFLAG_TI89)
            {
                if (romImage[i].version>ver89)
                {
                    latest89ROM=i;
                    ver89=romImage[i].version;
                }
            }
            else
            {
                if (romImage[i].version>verPlus)
                {
                    latestPlusROM=i;
                    verPlus=romImage[i].version;
                }
            }
        }
        if (!(type&ROMFLAG_FLASHROM))
        {
            if (romImage[i].type&ROMFLAG_FLASHROM)
            {
                use=i;
                type=romImage[i].type;
                ver=romImage[i].version;
            }
            else if (romImage[0].version>ver)
            {
                use=i;
                type=romImage[i].type;
                ver=romImage[i].version;
            }
        }
        else
        {
            if (type&ROMFLAG_TI89)
            {
                if ((!(romImage[i].type&ROMFLAG_TI89))&&
                    (romImage[i].type&ROMFLAG_FLASHROM))
                {
                    use=i;
                    type=romImage[i].type;
                    ver=romImage[i].version;
                }
                else if (romImage[i].type&ROMFLAG_TI89)
                {
                    if (romImage[i].version>ver)
                    {
                        use=i;
                        type=romImage[i].type;
                        ver=romImage[i].version;
                    }
                }
            }
            else
            {
                if (!(type&ROMFLAG_FLASHROM))
                {
                    if (type&ROMFLAG_FLASHROM)
                    {
                        use=i;
                        type=romImage[i].type;
                        ver=romImage[i].version;
                    }
                    else if (romImage[i].version>ver)
                    {
                        use=i;
                        type=romImage[i].type;
                        ver=romImage[i].version;
                    }
                }
                else
                {
                    if (romImage[i].type&ROMFLAG_FLASHROM)
                    {
                        if (romImage[i].version>ver)
                        {
                            use=i;
                            type=romImage[i].type;
                            ver=romImage[i].version;
                        }
                    }
                }
            }
        }
    }
    return use;
}

int LoadROM(int mode)
{
	FILE *fp;
	initialPC=0;
	initIntTabOfs=0;
	calc=92; intRom92=0; ramSize=256;
    rom92Present=0; rom92PlusPresent=0;
    rom89Present=0;
    plusMod=0;
    currentROM=mode;
    if (romImage[mode].type&ROMFLAG_UPDATE)
    {
        if (romImage[mode].type&ROMFLAG_TI89)
            currentROM=latest89ROM;
        else
            currentROM=latestPlusROM;
    }
    if (currentROM!=-1)
    {
    	fp=fopen(romImage[currentROM].file,"rb");
	    if (!fp)
        {
            MessageBox(NULL,"Could not open ROM image","Error",MB_OK);
            return 1;
        }
        for (int i=0;i<512;i++) romFuncAddr[i]=0;
        if (romImage[currentROM].type&ROMFLAG_INTERNAL)
        {
           	fread(intRom,romImage[currentROM].size,1,fp);
            if (romImage[currentROM].size<(2048*1024))
            {
                for (int i=0;i<0x100000;i++)
                    intRom[i+0x100000]=intRom[i];
            }
            if (romImage[currentROM].type&ROMFLAG_FLASHROM)
            {
                initialPC=readmem24_dword(0x21208c);
                initIntTabOfs=0x12088;
                FillROMAddrs(readmem24_dword(0x200000+initIntTabOfs+0xc8));
            }
            else
            {
                initialPC=readmem24_dword(0x200004);
                initIntTabOfs=0;
            }
        }
        else
        {
           	fread(extRom,romImage[currentROM].size,1,fp);
            if (romImage[currentROM].size<(2048*1024))
            {
                for (int i=0;i<0x100000;i++)
                    extRom[i+0x100000]=extRom[i];
            }
            if (romImage[currentROM].type&ROMFLAG_FLASHROM)
            {
                initialPC=readmem24_dword(0x41208c);
                initIntTabOfs=0x12088;
                plusMod=1;
                FillROMAddrs(readmem24_dword(0x400000+initIntTabOfs+0xc8));
            }
            else
            {
                initialPC=readmem24_dword(0x400004);
                initIntTabOfs=0;
            }
        }
        if (romImage[currentROM].type&ROMFLAG_TI89)
        {
            lcdWidth=160;
            lcdHeight=100;
		    calc=89;
        }
        else
        {
            lcdWidth=240;
            lcdHeight=128;
            calc=92;
        }
        fclose(fp);
	}
    if (romImage[mode].type&ROMFLAG_UPDATE)
    {
        currentROM=mode;
    	fp=fopen(romImage[currentROM].file,"rb");
	    if (!fp) return 0;
        if (romImage[mode].type&ROMFLAG_TI89)
        {
            for (int i=0x12000;i<0x200000;i++)
            {
                if (((i&0xffff)!=1)||(i<0x1a0000))
                    intRom[i]=0xff;
                else
                    intRom[i]=0xfe;
            }
           	fread(&intRom[0x12000],romImage[currentROM].size,1,fp);
            initialPC=readmem24_dword(0x21208c);
            initIntTabOfs=0x12088;
            FillROMAddrs(readmem24_dword(0x200000+initIntTabOfs+0xc8));
            lcdWidth=160;
            lcdHeight=100;
		    calc=89;
        }
        else
        {
            for (int i=0x12000;i<0x200000;i++)
            {
                if (((i&0xffff)!=1)||(i<0x1a0000))
                    extRom[i]=0xff;
                else
                    extRom[i]=0xfe;
            }
           	fread(&extRom[0x12000],romImage[currentROM].size,1,fp);
            initialPC=readmem24_dword(0x41208c);
            initIntTabOfs=0x12088;
            FillROMAddrs(readmem24_dword(0x400000+initIntTabOfs+0xc8));
            plusMod=1;
            lcdWidth=240;
            lcdHeight=128;
            calc=92;
        }
    }
    if (initialPC==0) return 1;
	return 0;
}

void RefreshLCDNow()
{
	int x,y,i,j,b,v0,v1,v2,v3,v4,v5,v,ofs,lofs;
	unsigned char *sptr;
    int rv[7],gv[7],bv[7];
    int cl;

    if (calc==89)
    {
        cl=contrast;
        for (i=0;i<7;i++)
        {
            irv[i]=irv89[i];
            igv[i]=igv89[i];
            ibv[i]=ibv89[i];
        }
    }
    else
    {
        cl=31-contrast;
        for (i=0;i<7;i++)
        {
            irv[i]=irv92[i];
            igv[i]=igv92[i];
            ibv[i]=ibv92[i];
        }
    }
    if (cpuCompleteStop) cl+=6;
    if (romErase)
    {
        if (calc!=89)
            cl+=contrastDelta[romErasePhase>>3];
        romErasePhase++;
        if (romErasePhase==64)
        {
            romErasePhase=0;
            romErase=0;
        }
    }
    if (cl>31) cl=31;
    if (cl<0) cl=0;
    if (!lcdOff)
    {
        if (cl>16)
        {
            rv[0]=irv[0]; rv[6]=irv[0]+((irv[6]-irv[0])*(32-cl))/16;
            gv[0]=igv[0]; gv[6]=igv[0]+((igv[6]-igv[0])*(32-cl))/16;
            bv[0]=ibv[0]; bv[6]=ibv[0]+((ibv[6]-ibv[0])*(32-cl))/16;
            rv[1]=rv[0]+(rv[6]-rv[0])/6;
            rv[2]=rv[0]+((rv[6]-rv[0])*2)/6;
            rv[3]=rv[0]+((rv[6]-rv[0])*3)/6;
            rv[4]=rv[0]+((rv[6]-rv[0])*4)/6;
            rv[5]=rv[0]+((rv[6]-rv[0])*5)/6;
            gv[1]=gv[0]+(gv[6]-gv[0])/6;
            gv[2]=gv[0]+((gv[6]-gv[0])*2)/6;
            gv[3]=gv[0]+((gv[6]-gv[0])*3)/6;
            gv[4]=gv[0]+((gv[6]-gv[0])*4)/6;
            gv[5]=gv[0]+((gv[6]-gv[0])*5)/6;
            bv[1]=bv[0]+(bv[6]-bv[0])/6;
            bv[2]=bv[0]+((bv[6]-bv[0])*2)/6;
            bv[3]=bv[0]+((bv[6]-bv[0])*3)/6;
            bv[4]=bv[0]+((bv[6]-bv[0])*4)/6;
            bv[5]=bv[0]+((bv[6]-bv[0])*5)/6;
        }
        else
        {
            rv[6]=irv[6]; rv[0]=irv[6]-((irv[6]-irv[0])*cl)/16;
            gv[6]=igv[6]; gv[0]=igv[6]-((igv[6]-igv[0])*cl)/16;
            bv[6]=ibv[6]; bv[0]=ibv[6]-((ibv[6]-ibv[0])*cl)/16;
            rv[1]=rv[0]+(rv[6]-rv[0])/6;
            rv[2]=rv[0]+((rv[6]-rv[0])*2)/6;
            rv[3]=rv[0]+((rv[6]-rv[0])*3)/6;
            rv[4]=rv[0]+((rv[6]-rv[0])*4)/6;
            rv[5]=rv[0]+((rv[6]-rv[0])*5)/6;
            gv[1]=gv[0]+(gv[6]-gv[0])/6;
            gv[2]=gv[0]+((gv[6]-gv[0])*2)/6;
            gv[3]=gv[0]+((gv[6]-gv[0])*3)/6;
            gv[4]=gv[0]+((gv[6]-gv[0])*4)/6;
            gv[5]=gv[0]+((gv[6]-gv[0])*5)/6;
            bv[1]=bv[0]+(bv[6]-bv[0])/6;
            bv[2]=bv[0]+((bv[6]-bv[0])*2)/6;
            bv[3]=bv[0]+((bv[6]-bv[0])*3)/6;
            bv[4]=bv[0]+((bv[6]-bv[0])*4)/6;
            bv[5]=bv[0]+((bv[6]-bv[0])*5)/6;
        }
        for (j=0;j<6;j++)
        {
        	for (i=0;i<3840;i++)
	        	oldScreen[j][i]=readmem24(oldScreenBase[j]+i);
        }
	    for (y=0,lofs=0;y<lcdHeight;y++,lofs+=30)
	    {
    		ofs=lofs;
    		for (x=0,sptr=ScreenLine[y];x<lcdWidth;x+=8,ofs++)
	    	{
		    	v0=oldScreen[0][ofs];
    			v1=oldScreen[1][ofs];
			    v2=oldScreen[2][ofs];
			    v3=oldScreen[3][ofs];
			    v4=oldScreen[4][ofs];
			    v5=oldScreen[5][ofs];
	    		for (i=7,b=0x80;i>=0;i--,b>>=1)
		    	{
    				j=0;
	    			if (v0&b) j++;
		    		if (v1&b) j++;
    				if (v2&b) j++;
    				if (v3&b) j++;
    				if (v4&b) j++;
    				if (v5&b) j++;
                    j=6-j;
                    *sptr=bv[j]; sptr++;
                    *sptr=gv[j]; sptr++;
                    *sptr=rv[j]; sptr++;
                    sptr++;
    			}
	    	}
    	}
    }
    else
    {
	    for (y=0,lofs=0;y<lcdHeight;y++,lofs+=30)
	    {
    		for (x=0,sptr=ScreenLine[y];x<lcdWidth;x++)
	    	{
                *sptr=ibv[6]; sptr++;
                *sptr=igv[6]; sptr++;
                *sptr=irv[6]; sptr++;
                sptr++;
	    	}
    	}
        if (!cpuCompleteStop)
        {
    		for (x=0,sptr=ScreenLine[43];x<lcdWidth;x++)
	    	{
                *sptr=ibv[0]; sptr++;
                *sptr=igv[0]; sptr++;
                *sptr=irv[0]; sptr++;
                sptr++;
	    	}
        }
    }
}

void RefreshLCD()
{
	int x,y,i,j,b,v0,v1,v2,v3,v4,v5,v,ofs,lofs;
	unsigned char *sptr;
    int rv[7],gv[7],bv[7];
    int cl;

    if (calc==89)
    {
        cl=contrast;
        for (i=0;i<7;i++)
        {
            irv[i]=irv89[i];
            igv[i]=igv89[i];
            ibv[i]=ibv89[i];
        }
    }
    else
    {
        cl=31-contrast;
        for (i=0;i<7;i++)
        {
            irv[i]=irv92[i];
            igv[i]=igv92[i];
            ibv[i]=ibv92[i];
        }
    }
    if (cpuCompleteStop) cl+=6;
    if (romErase)
    {
        if (calc!=89)
            cl+=contrastDelta[romErasePhase>>3];
        romErasePhase++;
        if (romErasePhase==64)
        {
            romErasePhase=0;
            romErase=0;
        }
    }
    if (cl>31) cl=31;
    if (cl<0) cl=0;
    if (!lcdOff)
    {
        if (cl>16)
        {
            rv[0]=irv[0]; rv[6]=irv[0]+((irv[6]-irv[0])*(32-cl))/16;
            gv[0]=igv[0]; gv[6]=igv[0]+((igv[6]-igv[0])*(32-cl))/16;
            bv[0]=ibv[0]; bv[6]=ibv[0]+((ibv[6]-ibv[0])*(32-cl))/16;
            rv[1]=rv[0]+(rv[6]-rv[0])/6;
            rv[2]=rv[0]+((rv[6]-rv[0])*2)/6;
            rv[3]=rv[0]+((rv[6]-rv[0])*3)/6;
            rv[4]=rv[0]+((rv[6]-rv[0])*4)/6;
            rv[5]=rv[0]+((rv[6]-rv[0])*5)/6;
            gv[1]=gv[0]+(gv[6]-gv[0])/6;
            gv[2]=gv[0]+((gv[6]-gv[0])*2)/6;
            gv[3]=gv[0]+((gv[6]-gv[0])*3)/6;
            gv[4]=gv[0]+((gv[6]-gv[0])*4)/6;
            gv[5]=gv[0]+((gv[6]-gv[0])*5)/6;
            bv[1]=bv[0]+(bv[6]-bv[0])/6;
            bv[2]=bv[0]+((bv[6]-bv[0])*2)/6;
            bv[3]=bv[0]+((bv[6]-bv[0])*3)/6;
            bv[4]=bv[0]+((bv[6]-bv[0])*4)/6;
            bv[5]=bv[0]+((bv[6]-bv[0])*5)/6;
        }
        else
        {
            rv[6]=irv[6]; rv[0]=irv[6]-((irv[6]-irv[0])*cl)/16;
            gv[6]=igv[6]; gv[0]=igv[6]-((igv[6]-igv[0])*cl)/16;
            bv[6]=ibv[6]; bv[0]=ibv[6]-((ibv[6]-ibv[0])*cl)/16;
            rv[1]=rv[0]+(rv[6]-rv[0])/6;
            rv[2]=rv[0]+((rv[6]-rv[0])*2)/6;
            rv[3]=rv[0]+((rv[6]-rv[0])*3)/6;
            rv[4]=rv[0]+((rv[6]-rv[0])*4)/6;
            rv[5]=rv[0]+((rv[6]-rv[0])*5)/6;
            gv[1]=gv[0]+(gv[6]-gv[0])/6;
            gv[2]=gv[0]+((gv[6]-gv[0])*2)/6;
            gv[3]=gv[0]+((gv[6]-gv[0])*3)/6;
            gv[4]=gv[0]+((gv[6]-gv[0])*4)/6;
            gv[5]=gv[0]+((gv[6]-gv[0])*5)/6;
            bv[1]=bv[0]+(bv[6]-bv[0])/6;
            bv[2]=bv[0]+((bv[6]-bv[0])*2)/6;
            bv[3]=bv[0]+((bv[6]-bv[0])*3)/6;
            bv[4]=bv[0]+((bv[6]-bv[0])*4)/6;
            bv[5]=bv[0]+((bv[6]-bv[0])*5)/6;
        }
    	for (i=0;i<3840;i++)
    		oldScreen[scrNum][i]=readmem24(lcdBase+i);
        oldScreenBase[scrNum]=lcdBase;
    	scrNum=(scrNum+1)%6;
        if (scrNum!=0) return;
    	for (y=0,lofs=0;y<lcdHeight;y++,lofs+=30)
    	{
    		ofs=lofs;
    		for (x=0,sptr=ScreenLine[y];x<lcdWidth;x+=8,ofs++)
    		{
    			v0=oldScreen[0][ofs];
    			v1=oldScreen[1][ofs];
    			v2=oldScreen[2][ofs];
    			v3=oldScreen[3][ofs];
    			v4=oldScreen[4][ofs];
    			v5=oldScreen[5][ofs];
    			for (i=7,b=0x80;i>=0;i--,b>>=1)
    			{
                    j=6-(((v0&b)+(v1&b)+(v2&b)+(v3&b)+(v4&b)+(v5&b))>>i);
                    *sptr=bv[j]; sptr++;
                    *sptr=gv[j]; sptr++;
                    *sptr=rv[j]; sptr++;
                    sptr++;
    			}
    		}
    	}
    }
    else
    {
        for (y=0,lofs=0;y<lcdHeight;y++,lofs+=30)
        {
    		for (x=0,sptr=ScreenLine[y];x<lcdWidth;x++)
	    	{
                *sptr=ibv[6]; sptr++;
                *sptr=igv[6]; sptr++;
                *sptr=irv[6]; sptr++;
                sptr++;
	    	}
    	}
        if (!cpuCompleteStop)
        {
    		for (x=0,sptr=ScreenLine[43];x<lcdWidth;x++)
	    	{
                *sptr=ibv[0]; sptr++;
                *sptr=igv[0]; sptr++;
                *sptr=irv[0]; sptr++;
                sptr++;
	    	}
        }
    }
}

void KeyDown(int row,int col,int row89,int col89)
{
	if (calc==92)
	{
		if (row!=-1)
			kbmatrix[row]&=~(1<<col);
	}
	else if (row89!=-1)
		kbmatrix[row89]&=~(1<<col89);
}

void KeyUp(int row,int col,int row89,int col89)
{
	if (calc==92)
	{
		if (row!=-1)
			kbmatrix[row]|=1<<col;
	}
	else if (row89!=-1)
		kbmatrix[row89]|=1<<col89;
}

void OnDown()
{
	onheld=0;
	IRQ(6);
}

void OnUp()
{
	onheld=1;
}

void InitCom()
{
	comError=0;
}

void SendCom(int b)
{
	int count;

	if (comError) return;
	recvflag=1;
	recvbyte=b;
    if (debugLogLinkRecv)
    {
        char str[32];
        sprintf(str,"Receive of %2.2X on link port",b&0xff);
        LogDlg->List->Items->Add(str);
    }
	IRQ(4);
	count=10000;
	while ((recvflag)&&(count--))
		DoInstruction();
	if (recvflag)
		comError=1;
}

int CheckCom()
{
    return transflag;
}

int GetCom(int *c)
{
	int count;

	if (comError) return 0;
	count=10000;
	while ((!transflag)&&(count--))
		DoInstruction();
	if (transflag)
	{
		*c=transbyte&0xff;
		transflag=0;
	}
	else
		comError=1;
    return *c;
}

int WaitForAck()
{
	int i;
	do
	{
		GetCom(&i);
		if (comError)
			break;
	} while (i!=0x89);
	GetCom(&i); GetCom(&i); GetCom(&i);
	return i;
}

int ComError()
{
	return comError;
}

int TransferFile(char *fn)
{
	FILE *fp;
	int csum,type,size,id=0x89;
	int i,j;
	char calcName[32],buf[16];

    if ((fn[strlen(fn)-1]=='B')||(fn[strlen(fn)-1]=='b'))
    {
        if ((calc!=92)||(plusMod))
        {
            MessageBox(NULL,"Cannot transfer backup file\n"
                "to TI-89 or TI-92 Plus","Error",MB_OK);
            return 1;
        }
        InitCom();
        fp=fopen(fn,"rb");
        fseek(fp,0x4c,SEEK_SET);
        fread(&size,4,1,fp);
        size-=0x54;
        fseek(fp,0x52,SEEK_SET);
       	if (ComError()) return 1;
        SendCom(id); SendCom(6);
    	SendCom(5); SendCom(0);
        SendCom(size&0xff);
        SendCom((size>>8)&0xff);
	    SendCom((size>>16)&0xff);
	    SendCom((size>>24)&0xff);
        csum=size&0xff; csum+=(size>>8)&0xff;
        csum+=(size>>16)&0xff; csum+=(size>>24)&0xff;
        SendCom(0x1d);
	    csum+=0x1d;
	    SendCom(csum&0xff); SendCom((csum>>8)&0xff);
        int pos=0;
        while (1)
        {
			WaitForAck();
            int segSize=1024;
            if (segSize>size) segSize=size;
	   	    SendCom(id); SendCom(6);
            SendCom(5); SendCom(0);
	        SendCom(segSize&0xff); SendCom((segSize>>8)&0xff);
            SendCom(0); SendCom(0);
	        SendCom(0x1d);
            csum=0x1d+(segSize&0xff)+((segSize>>8)&0xff);
            SendCom(csum&0xff); SendCom((csum>>8)&0xff);
	        WaitForAck(); WaitForAck();
	        SendCom(id); SendCom(0x56); SendCom(0); SendCom(0);
			SendCom(id); SendCom(0x15);
            SendCom(segSize&0xff); SendCom((segSize>>8)&0xff);
            csum=0;
			for (j=0;j<segSize;j++)
            {
		        i=fgetc(fp);
		    	SendCom(i);
			    csum+=i;
		        if (ComError()) break;
            }
	        csum&=0xffff;
		    SendCom(csum&0xff); SendCom((csum>>8)&0xff);
            size-=segSize;
            pos+=1024;
            if (size==0) break;
        }
        WaitForAck();
        SendCom(id); SendCom(0x92); SendCom(0); SendCom(0);
        fclose(fp);
        if (ComError()) return 1;
        return 0;
    }
	InitCom();
	fp=fopen(fn,"rb");
	if (!fp)
		return 1;
	fseek(fp,0x48,SEEK_SET);
	type=fgetc(fp);
	fseek(fp,0xa,SEEK_SET);
	fread(buf,8,1,fp);
	buf[8]=0; strcpy(calcName,buf);
	fseek(fp,0x40,SEEK_SET);
	fread(buf,8,1,fp);
	fseek(fp,0x4c,SEEK_SET);
	size=fgetc(fp);
	size|=fgetc(fp)<<8;
	size-=0x5a;
	buf[8]=0; strcat(calcName,"\\"); strcat(calcName,buf);
	id=0x89;
	SendCom(id); SendCom(6);
	SendCom(6+strlen(calcName));
	SendCom(0); SendCom((size+2)&0xff);
	SendCom(((size+2)>>8)&0xff);
	SendCom(0); SendCom(0);
	csum=(size+2)&0xff; csum+=((size+2)>>8)&0xff;
	SendCom(type);
	csum+=type;
	SendCom(strlen(calcName));
	csum+=strlen(calcName);
	for (i=0;i<strlen(calcName);i++)
	{
		SendCom(calcName[i]);
		csum+=calcName[i];
	}
	SendCom(csum&0xff); SendCom((csum>>8)&0xff);
	WaitForAck();
	WaitForAck();
	if (ComError())
	{
		fclose(fp);
		for (i=0;i<100;i++) DoInstruction();
		return 1;
	}
	SendCom(id); SendCom(0x56); SendCom(0); SendCom(0);
	SendCom(id); SendCom(0x15);
	SendCom((size+6)&0xff); SendCom(((size+6)>>8)&0xff);
	SendCom(0); SendCom(0); SendCom(0); SendCom(0);
	fseek(fp,0x56,SEEK_SET);
	csum=0;
	for (j=0;j<(size+2);j++)
	{
		 i=fgetc(fp);
		 SendCom(i);
		 csum+=i;
	}
	csum&=0xffff;
	SendCom(csum&0xff); SendCom((csum>>8)&0xff);
	WaitForAck();
	SendCom(id); SendCom(0x92); SendCom(0); SendCom(0);
	WaitForAck();
	fclose(fp);
	if (ComError())
	{
		printf("Error in transmission\n\n");
		return 1;
	}
	for (i=0;i<100;i++) DoInstruction();
    return 0;
}

void DoInstruction()
{
	static i=0;
	int j,f;

    if (!run) return;
   	i++;
    if (i>=8)
   	{
    	i=0;
	    int0Count++;
   		if (int0Count>3)
    	{
	    	int0Count=0;
   			IRQ(1);
    	}
	    if (int0Count==1) IRQ(4);
   		if (int0Count==2)
    	{
	    	for (j=0,f=0;j<10;j++)
   			{
    			if (kbmatrix[j]!=0xff)
	    			f=1;
   			}
    		if (f) { IRQ(2); }
	    }
   		lcdRefresh++;
    	if (lcdRefresh>15)
	    {
   			lcdRefresh=0;
    		RefreshLCD();
	    }
   		if (timer!=0)
    	{
	    	timer++;
   			timer&=0xff;
    	}
	    else
   		{
    		timer=timerInit;
   			IRQ(5);
    	}
   	}
    static int leftOver=0;
	leftOver=MC68000_Execute(625-leftOver)-(625-leftOver);
}

void DoOneInstruction()
{
    MC68000_Execute(1);
}

void CloseEmu();
int InitEmu(int mode);

int calcChanged;
#define InInt(x) fread(&x,4,1,fp);
void SaveState(char *name);
void LoadState(char *name)
{
    FILE *fp;
    if (name)
        fp=fopen(name,"rb");
    else
    {
        char str[32];
        strcpy(str,romImage[currentROM].file);
        str[strlen(str)-3]='s';
        str[strlen(str)-2]='a';
        str[strlen(str)-1]='v';
        fp=fopen(str,"rb");
    }
    int i;
    if (!fp)
        return;
    int newCalc,newPlusMod,newIntRom92;
    char romName[32];
    fread(romName,32,1,fp);
    InInt(newCalc); InInt(newPlusMod); InInt(newIntRom92);
    if (strcmp(romName,romImage[currentROM].file))
    {
        for (i=0;i<romImageCount;i++)
        {
            if (!strcmp(romName,romImage[i].file))
                break;
        }
        if (i==romImageCount)
            return;
        calcChanged=1;
        SaveState(NULL);
        CloseEmu();
        InitEmu(i);
    }
    InInt(ramSize); InInt(contrast); InInt(memprotect);
    InInt(ram128); InInt(timer); InInt(timerInit);
    InInt(int0Count); InInt(kbmask); InInt(ramWrap);
    InInt(memAnd); InInt(onheld); InInt(lcdBase);
    InInt(io0Bit2); InInt(io0Bit7);
    InInt(lcdWidth); InInt(lcdHeight);
    InInt(transflag); InInt(transbyte);
    InInt(transnotready); InInt(recvflag);
    InInt(recvbyte);
    InInt(romWriteReady); InInt(romWritePhase);
    InInt(romRetOr);
    InInt(lcdOff); InInt(cpuCompleteStop);
    for (i=0;i<10;i++) InInt(kbmatrix[i]);
    fread(&regs,sizeof(regs),1,fp);
    fread(ram,0x40000,1,fp);
    for (i=0;i<32;i++)
    {
        InInt(romChanged[i]);
        if (romChanged[i])
        {
            if (calc==89)
                fread(&intRom[i<<16],0x10000,1,fp);
            else
                fread(&extRom[i<<16],0x10000,1,fp);
        }
    }
    InInt(pending_interrupts);
    fclose(fp);
    MakeFromSR();
}

#define OutInt(x) fwrite(&x,4,1,fp);
void SaveState(char *name)
{
    FILE *fp;
    if (name)
        fp=fopen(name,"wb");
    else
    {
        char str[32];
        strcpy(str,romImage[currentROM].file);
        str[strlen(str)-3]='s';
        str[strlen(str)-2]='a';
        str[strlen(str)-1]='v';
        fp=fopen(str,"wb");
    }
    int i,j;
    if (!fp)
    {
        MessageBox(NULL,"Could not open output file","Error",MB_OK);
        return;
    }
    MakeSR();
    fwrite(romImage[currentROM].file,32,1,fp);
    OutInt(calc); OutInt(plusMod); OutInt(intRom92);
    OutInt(ramSize); OutInt(contrast); OutInt(memprotect);
    OutInt(ram128); OutInt(timer); OutInt(timerInit);
    OutInt(int0Count); OutInt(kbmask); OutInt(ramWrap);
    OutInt(memAnd); OutInt(onheld); OutInt(lcdBase);
    OutInt(io0Bit2); OutInt(io0Bit7);
    OutInt(lcdWidth); OutInt(lcdHeight);
    OutInt(transflag); OutInt(transbyte);
    OutInt(transnotready); OutInt(recvflag);
    OutInt(recvbyte);
    OutInt(romWriteReady); OutInt(romWritePhase);
    OutInt(romRetOr);
    OutInt(lcdOff); OutInt(cpuCompleteStop);
    for (i=0;i<10;i++) OutInt(kbmatrix[i]);
    fwrite(&regs,sizeof(regs),1,fp);
    fwrite(ram,0x40000,1,fp);
    BYTE *rom=(calc==89)?intRom:extRom;
    for (i=0;i<32;i++)
    {
        if (romChanged[i])
        {
            int change=0;
            for (j=0;j<0x10000;j++)
            {
                if (rom[(i<<16)+j]!=origRom[(i<<16)+j])
                {
                    change=1;
                    break;
                }
            }
            OutInt(change);
            if (change) fwrite(&rom[i<<16],0x10000,1,fp);
       }
       else
            OutInt(romChanged[i]);
    }
    OutInt(pending_interrupts);
    fclose(fp);
}

int InitEmu(int mode)
{
	int i,j,f;

    if (needPath)
    {
        needPath=0;
        getcwd(initPath,256);
    }
    else
        chdir(initPath);
	ExitEmulator=0; TransferState=0;
	for (i=0;i<10;i++) kbmatrix[i]=0xff;
	ram=(char*)malloc(256*1024);
	intRom=(char*)malloc(2048*1024);
	extRom=(char*)malloc(2048*1024);
    origRom=(char*)malloc(2048*1024);
	for (i=0;i<2048*1024;i++)
	{
		if (i&1)
		{
			intRom[i]=0;
			extRom[i]=0;
		}
		else
		{
			intRom[i]=0x14;
			extRom[i]=0x14;
		}
	}
	if (LoadROM(mode)) return 0;
    if (calc==92) memcpy(origRom,extRom,2048*1024);
    else memcpy(origRom,intRom,2048*1024);
    for (i=0;i<0x40000;i++)
        ram[i]=0;
	for (i=0;i<256;i++)
	{
		if (initialPC<0x400000)
			ram[i]=intRom[i+initIntTabOfs];
		else
			ram[i]=extRom[i+initIntTabOfs];
	}
	MC68000_Reset();
	regs.pc=initialPC;
	contrast=16;
	ram128=0;
	memprotect=0;
	kbmask=0xff;
	ramWrap=0; memAnd=0x3ffff;
	onheld=1; lcdBase=((calc==89)||plusMod)?0x4c00:0x4440;
	timer=0; timerInit=0xb2; int0Count=0;
	transflag=0; recvflag=0;
	transnotready=0;
	lcdRefresh=0;
    io0Bit2=1; io0Bit7=1;
    romWriteReady=0; romWritePhase=0; romRetOr=0;
    cpuCompleteStop=0; lcdOff=0;
    romErase=0;
    for (i=0;i<32;i++) romChanged[i]=0;
//	IRQ(0);
    return calc;
}

void ResetEmu()
{
    int i,mode;

    chdir(initPath);
	LoadROM(currentROM);
    for (i=0;i<0x40000;i++)
        ram[i]=0;
	for (i=0;i<256;i++)
	{
		if (initialPC<0x400000)
			ram[i]=intRom[i+initIntTabOfs];
		else
			ram[i]=extRom[i+initIntTabOfs];
	}
	MC68000_Reset();
	regs.pc=initialPC;
	contrast=16;
	ram128=0;
	memprotect=0;
	kbmask=0xff;
	ramWrap=0; memAnd=0x3ffff;
	onheld=1; lcdBase=((calc==89)||plusMod)?0x4c00:0x4440;
	timer=0; timerInit=0xb2; int0Count=0;
	transflag=0; recvflag=0;
	transnotready=0;
	lcdRefresh=0;
    io0Bit2=1; io0Bit7=1;
    romWriteReady=0; romWritePhase=0; romRetOr=0;
    cpuCompleteStop=0; lcdOff=0;
    romErase=0;
    for (i=0;i<32;i++) romChanged[i]=0;
//	IRQ(0);
}

void CloseEmu()
{
	free(ram); free(intRom); free(extRom);
}

int uk(int p)
{
//	printf("Read from unknown port I/O addr %X at PC %X\n",p,regs.pc);
	return 0;
}

int ukw(int p,int v)
{
//	printf("Write of %X to unknown port I/O addr %X at PC %X\n",v,p,regs.pc);
	return 0;
}

int ioReadByte(int p)
{
	int v,i;
	switch (p)
	{
		case 0: v=((contrast&1)<<5)|(io0Bit7<<7)|(io0Bit2<<2);
            io0Bit2=1;
            return v;
		case 1: return (memprotect<<2)|ram128;
		case 2: case 4: case 6: case 8: case 0xa: return 0x14;
		case 3: case 5: case 7: case 9: case 0xb: return 1;
		case 0xc: return 5|((1-transflag)<<1);//0x8d;
		case 0xd: return (recvflag<<5)|((1-transflag)<<6);
		case 0xe: return 0x10;
		case 0xf: IRQ(4); recvflag=0; return recvbyte;
		case 0x10: case 0x12: return 0x14;
		case 0x11: case 0x13: return 1;
		case 0x14: return 0x14;
		case 0x15: return 0x1b;
		case 0x16: return 0x14;
		case 0x17: return timer;
		case 0x18: return (kbmask>>8)&3;
		case 0x19: return kbmask&0xff;
		case 0x1a: return 0x14|(onheld<<1);
		case 0x1b: for (v=0xff,i=0;i<10;i++)
			   {
			   	if (!(kbmask&(1<<i)))
			   		v&=kbmatrix[i];
			   }
			   return v;
		case 0x1c: case 0x1e: return 0x14;
		case 0x1d: case 0x1f: return 1;
	}
    return 0;
}

void ioWriteByte(int p,int v)
{
	switch(p)
	{
		case 0: contrast=(contrast&(~1))|((v>>5)&1);
            io0Bit7=(v>>7)&1;
            io0Bit2=(v>>2)&1;
            break;
		case 1: ram128=v&1; memprotect=(v>>2)&1;
			memAnd=(ramWrap)?0x1ffff:(ram128?0x1ffff:0x3ffff);
			break;
		case 5: if (!(v&0x10)) cpuCompleteStop=1; break;
		case 0xc: break;
		case 0xd: break;
		case 0xe: break;
		case 0xf: transflag=1;
			  transbyte=v;
              if (debugLogLinkSend)
              {
                  char str[32];
                  sprintf(str,"Send of %2.2X to link port",v&0xff);
                  LogDlg->List->Items->Add(str);
              }
              IRQ(4);
			  break;
		case 0x10: lcdBase=(((lcdBase>>3)&0xff)|((v&0xff)<<8))<<3;
			   break;
		case 0x11: lcdBase=(((lcdBase>>3)&0xff00)|(v&0xff))<<3;
		           break;
		case 0x17: timerInit=v; break;
		case 0x18: kbmask=(kbmask&0xff)|((v&3)<<8); break;
		case 0x19: kbmask=(kbmask&0x300)|(v&0xff); break;
        case 0x1c: lcdOff=(v&0x80)>>7; break;
		case 0x1d: contrast=(contrast&1)|((v&15)<<1); break;
		default: ukw(p,v); break;
	}
}

int readmem24(int addr)
{
	if (addr<0x200000)
		return (ram[addr&memAnd])&0xff;
	else if (addr<0x400000)
		return (intRom[addr-0x200000])&0xff;
	else if (addr<0x600000)
		return (extRom[addr-0x400000])&0xff;
	else
		return (ioReadByte(addr&0x1f))&0xff;
}

int readmem24_word(int addr)
{
	return ((readmem24(addr)<<8)|readmem24(addr+1))&0xffff;
}

int readmem24_dword(int addr)
{
	return (readmem24(addr)<<24)|
	       (readmem24(addr+1)<<16)|
	       (readmem24(addr+2)<<8)|
	       readmem24(addr+3);
}

int _fastcall ReadRAMByte(int addr)
{
    return ram[addr&memAnd]&0xff;
}


int _fastcall ReadRAMWord(int addr)
{
    int v=(ram[addr&memAnd]&0xff)<<8;
    v|=ram[(addr+1)&memAnd]&0xff;
    return v;
}

int _fastcall ReadRAMDWord(int addr)
{
    int v=(ram[(addr)&memAnd]&0xff)<<24;
    v|=(ram[(addr+1)&memAnd]&0xff)<<16;
    v|=(ram[(addr+2)&memAnd]&0xff)<<8;
    v|=ram[(addr+3)&memAnd]&0xff;
    return v;
}

int _fastcall ReadIntROMByte(int addr)
{
    return (intRom[addr&0x1fffff]&0xff|romRetOr)^romErase;
}

int _fastcall ReadIntROMWord(int addr)
{
    int v=(intRom[addr&0x1fffff]&0xff)<<8;
    v|=intRom[(addr+1)&0x1fffff]&0xff;
    return (v|romRetOr)^romErase;
}

int _fastcall ReadIntROMDWord(int addr)
{
    int v=(intRom[(addr)&0x1fffff]&0xff)<<24;
    v|=(intRom[(addr+1)&0x1fffff]&0xff)<<16;
    v|=(intRom[(addr+2)&0x1fffff]&0xff)<<8;
    v|=intRom[(addr+3)&0x1fffff]&0xff;
    return (v|romRetOr)^romErase;
}

int _fastcall ReadExtROMByte(int addr)
{
    return (extRom[addr&0x1fffff]&0xff|romRetOr)^romErase;
}

int _fastcall ReadExtROMWord(int addr)
{
    int v=(extRom[addr&0x1fffff]&0xff)<<8;
    v|=extRom[(addr+1)&0x1fffff]&0xff;
    return (v|romRetOr)^romErase;
}

int _fastcall ReadExtROMDWord(int addr)
{
    int v=(extRom[(addr)&0x1fffff]&0xff)<<24;
    v|=(extRom[(addr+1)&0x1fffff]&0xff)<<16;
    v|=(extRom[(addr+2)&0x1fffff]&0xff)<<8;
    v|=extRom[(addr+3)&0x1fffff]&0xff;
    return (v|romRetOr)^romErase;
}

int _fastcall ReadIOByte(int addr)
{
    return readmem24(addr);
}

int _fastcall ReadIOWord(int addr)
{
    return readmem24_word(addr);
}

int _fastcall ReadIODWord(int addr)
{
    return readmem24_dword(addr);
}

extern int debugDataBreakCount;
extern int debugDataBreakType[256];
extern int debugDataBreakLow[256];
extern int debugDataBreakHigh[256];
extern int debugLogEnable;
extern int debugLogCount;
extern int debugLogClass[256];
extern int debugLogType[256];
extern int debugLogLow[256];
extern int debugLogHigh[256];
extern int debugLogCheck[256];
extern int debugLogLast[256];
extern int debugLogState[256];
extern int debugLogAny[256];

int inline CheckAddr(int addr,int size,int type,int v)
{
    int i;
    for (i=0;i<debugDataBreakCount;i++)
    {
        if (!(debugDataBreakType[i]&type)) continue;
        if ((addr>(debugDataBreakLow[i]-size))&&
            (addr<=debugDataBreakHigh[i]))
            return 1;
    }
    for (i=0;i<debugLogCount;i++)
    {
        if (debugLogClass[i]==LOG_VALUE)
        {
            if (!(debugLogType[i]&type)) continue;
            if ((addr>(debugLogLow[i]-size))&&
                (addr<=debugLogHigh[i]))
            {
                char str[64];
                if (type==DATABREAK_READ)
                {
                    if (size==1)
                        sprintf(str,"Read byte %2.2X from %X at PC=%X",readmem24(addr)&0xff,addr,regs.pc&0xffffff);
                    else if (size==2)
                        sprintf(str,"Read word %4.4X from %X at PC=%X",readmem24_word(addr)&0xffff,addr,regs.pc&0xffffff);
                    else
                        sprintf(str,"Read long %8.8X from %X at PC=%X",readmem24_dword(addr),addr,regs.pc&0xffffff);
                }
                else
                {
                    if (size==1)
                        sprintf(str,"Write byte %2.2X to %X at PC=%X",v&0xff,addr,regs.pc&0xffffff);
                    else if (size==2)
                        sprintf(str,"Write word %4.4X to %X at PC=%X",v&0xffff,addr,regs.pc&0xffffff);
                    else
                        sprintf(str,"Write long %8.8X to %X at PC=%X",v,addr,regs.pc&0xffffff);
                }
                LogDlg->List->Items->Add(str);
            }
        }
        else
        {
            if (type==DATABREAK_READ) continue;
            if (!((addr>(debugLogLow[i]-size))&&
                  (addr<=debugLogLow[i])))
                continue;
            int j,b,nv;
            char str[64];
            nv=v&0xff;
            if (size==2)
            {
                if ((debugLogLow[i]-addr)==0)
                    nv=(v>>8)&0xff;
                else
                    nv=v&0xff;
            }
            else if (size==4)
            {
                if ((debugLogLow[i]-addr)==0)
                    nv=(v>>24)&0xff;
                else if ((debugLogLow[i]-addr)==1)
                    nv=(v>>16)&0xff;
                else if ((debugLogLow[i]-addr)==2)
                    nv=(v>>8)&0xff;
                else if ((debugLogLow[i]-addr)==3)
                    nv=v&0xff;
            }
            for (j=0,b=1;j<8;j++,b<<=1)
            {
                if (!debugLogCheck[i]&b) continue;
                if (debugLogAny[i]&b)
                {
                    if ((debugLogLast[i]&b)!=(nv&b))
                    {
                        if (nv&b)
                            sprintf(str,"Set bit %d of %X at PC=%X",j,debugLogLow[i],regs.pc&0xffffff);
                        else
                            sprintf(str,"Clear bit %d of %X at PC=%X",j,debugLogLow[i],regs.pc&0xffffff);
                        LogDlg->List->Items->Add(str);
                    }
                }
                else
                {
                    if ((debugLogLast[i]&b)==(nv&b)) continue;
                    if ((debugLogState[i]&b)==(nv&b))
                    {
                        if (nv&b)
                            sprintf(str,"Set bit %d of %X at PC=%X",j,debugLogLow[i],regs.pc&0xffffff);
                        else
                            sprintf(str,"Clear bit %d of %X at PC=%X",j,debugLogLow[i],regs.pc&0xffffff);
                        LogDlg->List->Items->Add(str);
                    }
                }
            }
            debugLogLast[i]=v;
        }
    }
    return 0;
}

extern int debugDataBreak;

void inline DataBreak()
{
    debugDataBreak=1;
}

int _fastcall DebugReadRAMByte(int addr)
{
    if (CheckAddr(addr,1,DATABREAK_READ,0)) DataBreak();
    return ram[addr&memAnd]&0xff;
}

int _fastcall DebugReadRAMWord(int addr)
{
    if (CheckAddr(addr,2,DATABREAK_READ,0)) DataBreak();
    int v=(ram[addr&memAnd]&0xff)<<8;
    v|=ram[(addr+1)&memAnd]&0xff;
    return v;
}

int _fastcall DebugReadRAMDWord(int addr)
{
    if (CheckAddr(addr,4,DATABREAK_READ,0)) DataBreak();
    int v=(ram[(addr)&memAnd]&0xff)<<24;
    v|=(ram[(addr+1)&memAnd]&0xff)<<16;
    v|=(ram[(addr+2)&memAnd]&0xff)<<8;
    v|=ram[(addr+3)&memAnd]&0xff;
    return v;
}

int _fastcall DebugReadIntROMByte(int addr)
{
    if (CheckAddr(addr,1,DATABREAK_READ,0)) DataBreak();
    return (intRom[addr&0x1fffff]&0xff|romRetOr)^romErase;
}

int _fastcall DebugReadIntROMWord(int addr)
{
    if (CheckAddr(addr,2,DATABREAK_READ,0)) DataBreak();
    int v=(intRom[addr&0x1fffff]&0xff)<<8;
    v|=intRom[(addr+1)&0x1fffff]&0xff;
    return (v|romRetOr)^romErase;
}

int _fastcall DebugReadIntROMDWord(int addr)
{
    if (CheckAddr(addr,4,DATABREAK_READ,0)) DataBreak();
    int v=(intRom[(addr)&0x1fffff]&0xff)<<24;
    v|=(intRom[(addr+1)&0x1fffff]&0xff)<<16;
    v|=(intRom[(addr+2)&0x1fffff]&0xff)<<8;
    v|=intRom[(addr+3)&0x1fffff]&0xff;
    return (v|romRetOr)^romErase;
}

int _fastcall DebugReadExtROMByte(int addr)
{
    if (CheckAddr(addr,1,DATABREAK_READ,0)) DataBreak();
    return (extRom[addr&0x1fffff]&0xff|romRetOr)^romErase;
}

int _fastcall DebugReadExtROMWord(int addr)
{
    if (CheckAddr(addr,2,DATABREAK_READ,0)) DataBreak();
    int v=(extRom[addr&0x1fffff]&0xff)<<8;
    v|=extRom[(addr+1)&0x1fffff]&0xff;
    return (v|romRetOr)^romErase;
}

int _fastcall DebugReadExtROMDWord(int addr)
{
    if (CheckAddr(addr,4,DATABREAK_READ,0)) DataBreak();
    int v=(extRom[(addr)&0x1fffff]&0xff)<<24;
    v|=(extRom[(addr+1)&0x1fffff]&0xff)<<16;
    v|=(extRom[(addr+2)&0x1fffff]&0xff)<<8;
    v|=extRom[(addr+3)&0x1fffff]&0xff;
    return (v|romRetOr)^romErase;
}

int _fastcall DebugReadIOByte(int addr)
{
    if (CheckAddr(addr,1,DATABREAK_READ,0)) DataBreak();
    return readmem24(addr);
}

int _fastcall DebugReadIOWord(int addr)
{
    if (CheckAddr(addr,2,DATABREAK_READ,0)) DataBreak();
    return readmem24_word(addr);
}

int _fastcall DebugReadIODWord(int addr)
{
    if (CheckAddr(addr,4,DATABREAK_READ,0)) DataBreak();
    return readmem24_dword(addr);
}

int cpu_readmem24(int addr)
{
    return ReadByte[(addr>>20)&0xf](addr);
}

int cpu_readmem24_word(int addr)
{
    if (addr&1) { ::Exception(3,0); return 0; }
    return ReadWord[(addr>>20)&0xf](addr);
}

int cpu_readmem24_dword(int addr)
{
    if (addr&1) { ::Exception(3,0); return 0; }
    return ReadDWord[(addr>>20)&0xf](addr);
}

void intRomWriteByte(int addr,int v)
{
    if (calc!=89) return;
    if (romWriteReady)
    {
//        if ((intRom[addr]==0xff)||(romWriteReady==1))
        {
            intRom[addr]=v;
            romChanged[addr>>16]=1;
        }
//        else
//            romWriteReady--;
        romWriteReady--;
        romRetOr=0xffffffff;
    }
    else if (v==0x50)
        romWritePhase=0x50;
    else if (v==0x10)
    {
        if (romWritePhase==0x50)
            romWritePhase=0x51;
        else if (romWritePhase==0x51)
        {
            romWriteReady=2;
            romWritePhase=0x50;
        }
    }
    else if (v==0x20)
    {
        if (romWritePhase==0x50)
            romWritePhase=0x20;
    }
    else if (v==0xd0)
    {
        if (romWritePhase==0x20)
        {
            romWritePhase=0xd0;
            romRetOr=0xffffffff;
            romErase=0xffffffff;
            romErasePhase=0;
            for (int i=0;i<0x10000;i++)
                intRom[(addr&0x1f0000)+i]=0xff;
            romChanged[addr>>16]=1;
        }
    }
    else if (v==0xff)
    {
        if (romWritePhase==0x50)
        {
            romWriteReady=0;
            romRetOr=0;
        }
    }
}

void extRomWriteByte(int addr,int v)
{
    if ((calc!=92)||(!plusMod)) return;
    if (romWriteReady)
    {
        if ((extRom[addr]==0xff)||(romWriteReady==1))
        {
            extRom[addr]=v;
            romChanged[addr>>16]=1;
        }
        else
            romWriteReady--;
        romWriteReady--;
        romRetOr=0xffffffff;
    }
    else if (v==0x50)
        romWritePhase=0x50;
    else if (v==0x10)
    {
        if (romWritePhase==0x50)
            romWritePhase=0x51;
        else if (romWritePhase==0x51)
        {
            romWriteReady=2;
            romWritePhase=0x50;
        }
    }
    else if (v==0x20)
    {
        if (romWritePhase==0x50)
            romWritePhase=0x20;
    }
    else if (v==0xd0)
    {
        if (romWritePhase==0x20)
        {
            romWritePhase=0xd0;
            romRetOr=0xffffffff;
            romErase=0xffffffff;
            romErasePhase=0;
            for (int i=0;i<0x10000;i++)
                extRom[(addr&0x1f0000)+i]=0xff;
            romChanged[addr>>16]=1;
        }
    }
    else if (v==0xff)
    {
        if (romWritePhase==0x50)
        {
            romWriteReady=0;
            romRetOr=0;
        }
    }
}

static int nocheck=0;
void cpu_writemem24(int addr,int v)
{
    if (!nocheck)
    {
        if (CheckAddr(addr,1,DATABREAK_WRITE,v))
            DataBreak();
    }
    addr&=0xffffff;
    if (addr<0x100)
    {
        if (memprotect)
        {
            ::Exception(24+7,0);
            return;
        }
        ram[addr]=v;
    }
	else if (addr<0x200000)
		ram[addr&memAnd]=v;
    else if (addr<0x400000)
        intRomWriteByte(addr&0x1fffff,v);
    else if (addr<0x600000)
        extRomWriteByte(addr&0x1fffff,v);
	else if (addr<0x800000)
		ioWriteByte(addr&0x1f,v);
}

void cpu_writemem24_word(int addr,int v)
{
    if (addr&1) { ::Exception(3,0); return; }
    if (CheckAddr(addr,2,DATABREAK_WRITE,v)) DataBreak();
    nocheck=1;
	cpu_writemem24(addr,(v>>8)&0xff);
	cpu_writemem24(addr+1,v&0xff);
    nocheck=0;
}

void cpu_writemem24_dword(int addr,int v)
{
    if (addr&1) { ::Exception(3,0); return; }
    if (CheckAddr(addr,4,DATABREAK_WRITE,v)) DataBreak();
    nocheck=1;
	cpu_writemem24(addr,(v>>24)&0xff);
	cpu_writemem24(addr+1,(v>>16)&0xff);
	cpu_writemem24(addr+2,(v>>8)&0xff);
	cpu_writemem24(addr+3,v&0xff);
    nocheck=0;
}

void writemem24(int addr,int v)
{
    if (CheckAddr(addr,1,DATABREAK_WRITE,v)) DataBreak();
    addr&=0xffffff;
	if (addr<0x200000)
		ram[addr&memAnd]=v;
    else if (addr<0x400000)
        intRomWriteByte(addr&0x1fffff,v);
    else if (addr<0x600000)
        extRomWriteByte(addr&0x1fffff,v);
	else if (addr<0x800000)
		ioWriteByte(addr&0x1f,v);
}

void writemem24_word(int addr,int v)
{
    if (CheckAddr(addr,2,DATABREAK_WRITE,v)) DataBreak();
	writemem24(addr,(v>>8)&0xff);
	writemem24(addr+1,v&0xff);
}

void writemem24_dword(int addr,int v)
{
    if (CheckAddr(addr,4,DATABREAK_WRITE,v)) DataBreak();
	writemem24(addr,(v>>24)&0xff);
	writemem24(addr+1,(v>>16)&0xff);
	writemem24(addr+2,(v>>8)&0xff);
	writemem24(addr+3,v&0xff);
}

void UseDebugReadFuncs()
{
    ReadByte[0]=DebugReadRAMByte; ReadByte[1]=DebugReadRAMByte;
    ReadByte[2]=DebugReadIntROMByte; ReadByte[3]=DebugReadIntROMByte;
    ReadByte[4]=DebugReadExtROMByte; ReadByte[5]=DebugReadExtROMByte;
    ReadByte[6]=DebugReadIOByte; ReadByte[7]=DebugReadIOByte;
    ReadByte[8]=DebugReadRAMByte; ReadByte[9]=DebugReadRAMByte;
    ReadByte[10]=DebugReadIntROMByte; ReadByte[11]=DebugReadIntROMByte;
    ReadByte[12]=DebugReadExtROMByte; ReadByte[13]=DebugReadExtROMByte;
    ReadByte[14]=DebugReadIOByte; ReadByte[15]=DebugReadIOByte;
    ReadWord[0]=DebugReadRAMWord; ReadWord[1]=DebugReadRAMWord;
    ReadWord[2]=DebugReadIntROMWord; ReadWord[3]=DebugReadIntROMWord;
    ReadWord[4]=DebugReadExtROMWord; ReadWord[5]=DebugReadExtROMWord;
    ReadWord[6]=DebugReadIOWord; ReadWord[7]=DebugReadIOWord;
    ReadWord[8]=DebugReadRAMWord; ReadWord[9]=DebugReadRAMWord;
    ReadWord[10]=DebugReadIntROMWord; ReadWord[11]=DebugReadIntROMWord;
    ReadWord[12]=DebugReadExtROMWord; ReadWord[13]=DebugReadExtROMWord;
    ReadWord[14]=DebugReadIOWord; ReadWord[15]=DebugReadIOWord;
    ReadDWord[0]=DebugReadRAMDWord; ReadDWord[1]=DebugReadRAMDWord;
    ReadDWord[2]=DebugReadIntROMDWord; ReadDWord[3]=DebugReadIntROMDWord;
    ReadDWord[4]=DebugReadExtROMDWord; ReadDWord[5]=DebugReadExtROMDWord;
    ReadDWord[6]=DebugReadIODWord; ReadDWord[7]=DebugReadIODWord;
    ReadDWord[8]=DebugReadRAMDWord; ReadDWord[9]=DebugReadRAMDWord;
    ReadDWord[10]=DebugReadIntROMDWord; ReadDWord[11]=DebugReadIntROMDWord;
    ReadDWord[12]=DebugReadExtROMDWord; ReadDWord[13]=DebugReadExtROMDWord;
    ReadDWord[14]=DebugReadIODWord; ReadDWord[15]=DebugReadIODWord;
}

void RestoreReadFuncs()
{
    ReadByte[0]=ReadRAMByte; ReadByte[1]=ReadRAMByte;
    ReadByte[2]=ReadIntROMByte; ReadByte[3]=ReadIntROMByte;
    ReadByte[4]=ReadExtROMByte; ReadByte[5]=ReadExtROMByte;
    ReadByte[6]=ReadIOByte; ReadByte[7]=ReadIOByte;
    ReadByte[8]=ReadRAMByte; ReadByte[9]=ReadRAMByte;
    ReadByte[10]=ReadIntROMByte; ReadByte[11]=ReadIntROMByte;
    ReadByte[12]=ReadExtROMByte; ReadByte[13]=ReadExtROMByte;
    ReadByte[14]=ReadIOByte; ReadByte[15]=ReadIOByte;
    ReadWord[0]=ReadRAMWord; ReadWord[1]=ReadRAMWord;
    ReadWord[2]=ReadIntROMWord; ReadWord[3]=ReadIntROMWord;
    ReadWord[4]=ReadExtROMWord; ReadWord[5]=ReadExtROMWord;
    ReadWord[6]=ReadIOWord; ReadWord[7]=ReadIOWord;
    ReadWord[8]=ReadRAMWord; ReadWord[9]=ReadRAMWord;
    ReadWord[10]=ReadIntROMWord; ReadWord[11]=ReadIntROMWord;
    ReadWord[12]=ReadExtROMWord; ReadWord[13]=ReadExtROMWord;
    ReadWord[14]=ReadIOWord; ReadWord[15]=ReadIOWord;
    ReadDWord[0]=ReadRAMDWord; ReadDWord[1]=ReadRAMDWord;
    ReadDWord[2]=ReadIntROMDWord; ReadDWord[3]=ReadIntROMDWord;
    ReadDWord[4]=ReadExtROMDWord; ReadDWord[5]=ReadExtROMDWord;
    ReadDWord[6]=ReadIODWord; ReadDWord[7]=ReadIODWord;
    ReadDWord[8]=ReadRAMDWord; ReadDWord[9]=ReadRAMDWord;
    ReadDWord[10]=ReadIntROMDWord; ReadDWord[11]=ReadIntROMDWord;
    ReadDWord[12]=ReadExtROMDWord; ReadDWord[13]=ReadExtROMDWord;
    ReadDWord[14]=ReadIODWord; ReadDWord[15]=ReadIODWord;
}

