#include <vcl.h>
#include <stdio.h>
#include "dumprom.h"

static HANDLE hCom=NULL;
static int error=0;
static unsigned char* ptr;

static void InitCom(int n)
{
    char name[8],str[256];
    DCB dcb;

    sprintf(name,"COM%d:",n);
    hCom=CreateFile(name,GENERIC_READ|GENERIC_WRITE,0,NULL,
        OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
    if (!hCom)
    {
        MessageBox(NULL,"Error opening COM port","Error",MB_OK);
        return;
    }
    dcb.DCBlength=sizeof(DCB);
    dcb.BaudRate=CBR_9600; dcb.ByteSize=8; dcb.Parity=0;
    dcb.StopBits=0;
    dcb.fNull=0; dcb.fBinary=1; dcb.fParity=0;
    dcb.fOutxCtsFlow=1; dcb.fOutxDsrFlow=1;
    dcb.fDtrControl=0; dcb.fOutX=0; dcb.fInX=0;
    dcb.fErrorChar=0; dcb.fRtsControl=RTS_CONTROL_ENABLE;
    SetupComm(hCom,1024,1024);
    GetCommState(hCom,&dcb);
    sprintf(str,"COM%d: baud=9600 parity=N data=8 stop=1",n);
    BuildCommDCB(str,&dcb);
    dcb.fNull=0;
    SetCommState(hCom,&dcb);
    COMMTIMEOUTS to;
    to.ReadIntervalTimeout=MAXDWORD;
    to.ReadTotalTimeoutMultiplier=0;
    to.ReadTotalTimeoutConstant=1000;
    to.WriteTotalTimeoutMultiplier=0;
    to.WriteTotalTimeoutConstant=0;
    SetCommTimeouts(hCom,&to);
    error=0;
}

static void CloseCom()
{
	if (hCom) CloseHandle(hCom);
}

static void SendCom(int ch)
{
    if (error) return;
    DWORD i;
    WriteFile(hCom,&ch,1,&i,NULL);
}

static int GetCom(int *ch)
{
    if (error) return 0;
    DWORD i;
    unsigned char c;
    if (!ReadFile(hCom,&c,1,&i,NULL))
        error=1;
    if (!i) error=1;
    *ch=c;
    return i;
}

static int ComError()
{
    return error;
}

static int WaitForAck()
{
    int i;
    GetCom(&i); GetCom(&i); GetCom(&i); GetCom(&i);
    return i;
}

#define seek(a,b,c) ptr=&(dumpRom[b])
#define get(a) *(ptr++)
#define read(a,b,c,d) memcpy(a,ptr,b*c)

int SendFile(int port)
{
    int csum,type,size,id,i,j;
    char calcName[32],buf[16];

    InitCom(port);
    ptr=dumpRom;
    seek(fp,0x48,SEEK_SET);
    type=get(fp);
    seek(fp,0xa,SEEK_SET);
    read(buf,8,1,fp);
    buf[8]=0; strcpy(calcName,buf);
    seek(fp,0x40,SEEK_SET);
    read(buf,8,1,fp);
    seek(fp,0x4c,SEEK_SET);
    size=get(fp);
    size|=get(fp)<<8;
    size-=0x5a;
    buf[8]=0; strcat(calcName,"\\"); strcat(calcName,buf);
    id=0x89;
    SendCom(id); SendCom(6);
    SendCom(6+strlen(calcName));
    SendCom(0); SendCom((size+2)&0xff);
    SendCom(((size+2)>>8)&0xff);
    SendCom(0); SendCom(0);
    csum=(size+2)&0xff; csum+=((size+2)>>8)&0xff;
    SendCom(type);
    csum+=type;
    SendCom(strlen(calcName));
    csum+=strlen(calcName);
    for (i=0;i<strlen(calcName);i++)
    {
	SendCom(calcName[i]);
        csum+=calcName[i];
    }
    SendCom(csum&0xff); SendCom((csum>>8)&0xff);
    WaitForAck(); WaitForAck();
    SendCom(id); SendCom(0x56); SendCom(0); SendCom(0);
    SendCom(id); SendCom(0x15);
    SendCom((size+6)&0xff); SendCom(((size+6)>>8)&0xff);
    SendCom(0); SendCom(0); SendCom(0); SendCom(0);
    if (ComError())
    {
        CloseCom();
//        printf("Error in transmission\n");
        return 1;
    }
    seek(fp,0x56,SEEK_SET);
    csum=0;
    for (j=0;j<(size+2);j++)
    {
        i=get(fp);
        SendCom(i);
        csum+=i;
    }
    csum&=0xffff;
    SendCom(csum&0xff); SendCom((csum>>8)&0xff);
    WaitForAck();
    SendCom(id); SendCom(0x92); SendCom(0); SendCom(0);
    WaitForAck();
    CloseCom();
    if (ComError())
    {
//        printf("Error in transmission\n");
        return 1;
    }
    return 0;
}

